var LOGFILE_NAME = "sonos-controller.log";

var lWarn = {
		logln : function(o) {
		}
	};
	var lInfo = {
		logln : function(o) {
		}
	};

//lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);

function executeAction(sUrl, bAutoStop, desiredVolume,rooms, curl_options){
  var baseNode = Property.getNode('sonos-players');
  var arrayPlayers = new Array();
  var sPlayerIP = "";
  var testablePlayer;
  var bPlay = (sUrl != "");
  lInfo.logln('executeAction ' + sUrl + ' + ' + desiredVolume + ' in ' + JSON.stringify(rooms));
  if (baseNode != null) {
    var arrayPlayers = baseNode.getChildren();
    if (arrayPlayers!=null) {
      for (var iIndex=0;iIndex<arrayPlayers.length;iIndex++) {
        if (!JSON.parse(arrayPlayers[iIndex].getChild('disabled').getValue())) {
          sPlayerIP = arrayPlayers[iIndex].getChild('ipAddress').getValue();
          var sDeviceID = arrayPlayers[iIndex].getChild('deviceID').getValue();
          var fShouldPlay=true;
          if (rooms!=null) {
        	  Property.setProperty('temporaryPlaying/rooms',JSON.stringify(rooms));
              fShouldPlay=false;
              for (var lIndex=0;lIndex<rooms.length;lIndex++) 
                  if (rooms[lIndex]==arrayPlayers[iIndex].getChild('roomID').getValue())
                      fShouldPlay=true;                      
          }
          if (bPlay && fShouldPlay) {
        	var fTest=upnpGetVolume(sPlayerIP, curl_options);
        	if (fTest!=null) {
        		testablePlayer=sPlayerIP;
	            upnpClearQueue(sPlayerIP, curl_options);
	            upnpLoadPlaylist(sPlayerIP, sUrl, curl_options);
	            
	            upnpSetContentSrc(sPlayerIP, "x-rincon-queue:"+sDeviceID+"#0", curl_options);
	            upnpSeek(sPlayerIP, true, 1, curl_options);
	            upnpSetMute(sPlayerIP,false,curl_options)
	            if (desiredVolume!=-1)
	                upnpSetVolume(sPlayerIP,desiredVolume,curl_options);
	            upnpPlay(sPlayerIP, curl_options);
	            upnpSetPlayMode(sPlayerIP, "NORMAL", curl_options);
        	}
          }
          else
        	  if (fShouldPlay)
        		  upnpStop(sPlayerIP, curl_options);
        }
      }
    }
  }
   
  if (bPlay && bAutoStop && testablePlayer != "") {
    lInfo.logln("Get track length, execute timer");
    var objCurrentTrack = upnpGetCurrentTrack(testablePlayer, curl_options);
    if (objCurrentTrack != null) {
      var nLength = secondToInt(unescape(objCurrentTrack.length));
      if (!isNaN(nLength)) {
        lInfo.logln("Length="+nLength);
        (new Event('sonos-controller-test-play-stopped',{time : '+'+nLength })).raise();
      }
    }
  }
}

if (raisedEvent.name === 'sonos-controller.testPlay') {
  Property.load();
  var curl_options = new Object({'debug' : 0, 'connectTimeout' : 200}); 
  lInfo.logln("sonos-controller.testPlay");
 
  if (raisedEvent.parameter.actions=='play') {
    lInfo.logln("Manual play");
    var playParams = JSON.parse(unescape(raisedEvent.parameter.value));
    var bAutoStop = JSON.parse(playParams.autoStop);
    var bT2sCreateFile = JSON.parse(playParams.t2sCreateFile);
    var desiredVolume = -1;
    if (playParams.nDesiredVolume!=null)
        desiredVolume=JSON.parse(playParams.nDesiredVolume);
    var sDeleteOldFileGuid = "";
    if (playParams.t2sDeleteGuid != null && playParams.t2sDeleteGuid != "") {
      sDeleteOldFileGuid = playParams.t2sDeleteGuid;
    } 
    var t2sFolder = "";
    if (playParams.t2sFolder != null)
      t2sFolder = (playParams.t2sFolder);
    switch(parseInt("" + playParams.nActionType)) {
      case 1:
      case 2:
        var sCall = unescape(playParams.sUrlCall);
        if (sCall != "")
          executeAction(sCall, bAutoStop,desiredVolume,playParams.rooms, curl_options);
        else
          lInfo.logln("Empty execution call");
      break;
      
      case 3:
      case 4:
        if (!bT2sCreateFile) {
          cloudService.fetchMediaFile(unescape(playParams.sUrlCall), function (oData) {
            if (oData.ReturnMessage == "OK") {
              lInfo.logln("Media url="+oData.Response.UrlPath);
              if (oData.Response.UrlPath != "")
                executeAction(unescape(oData.Response.UrlPath), true,desiredVolume,playParams.rooms, curl_options);
            }
          });
        }
        else {
          cloudService.createTextSound(t2sFolder, playParams.t2sLang, playParams.t2sVoice, unescape(playParams.t2sText), function (oData) {
            if (oData.ReturnMessage == "OK") {
              lInfo.logln("createTextSound="+oData.Response.TextToSpeechVoiceFileGuid);
              if (oData.Response.TextToSpeechVoiceFileGuid != "") {
                cloudService.fetchMediaFile(unescape(oData.Response.TextToSpeechVoiceFileGuid), function (oData2) {
                  if (oData2.ReturnMessage == "OK") {
                    lInfo.logln("Media url="+oData.Response.UrlPath);
                    if (oData2.Response.UrlPath != "")
                      executeAction(unescape(oData2.Response.UrlPath), true, desiredVolume,playParams.rooms,curl_options);
                  }
                });
              }
            }
            var evt = new Event("sonos-controller-test-t2s-create", {value: JSON.stringify(oData)});
            evt.raise();
          });
          
          // 
          if (sDeleteOldFileGuid != "") {
            cloudService.deleteTextSound(sDeleteOldFileGuid, function (oData) {
              lInfo.logln('getting deleteTextSound for['+sDeleteOldFileGuid+'] : ' + JSON.stringify(oData));
            });
          }
        }
      break;
    }
  }
  else 
  if (raisedEvent.parameter.actions=='stop') {
    lInfo.logln("Manual stop");
    var rooms=null;
    if (Property.getNode('temporaryPlaying/rooms')!=null)
    	rooms=JSON.parse(Property.getProperty('temporaryPlaying/rooms'));
    executeAction("", false, -1,rooms, curl_options);
    if (Property.getNode('temporaryPlaying')!=null)
    	Property.getNode('temporaryPlaying').removeChild('rooms');
  }
  else
  if (raisedEvent.parameter.actions=='delete') {
    lInfo.logln("Manual delete");
    
    var sText = unescape(raisedEvent.parameter.value);
    lInfo.logln("Manual delete for "+sText);
    cloudService.deleteTextSound(sText, function (oData) {
      lInfo.logln('getting deleteTextSound for['+sText+'] : ' + JSON.stringify(oData));
    });
    if (Property.getNode('temporaryPlaying')!=null)
    	Property.getNode('temporaryPlaying').removeChild('rooms');
  }
  else
  if (raisedEvent.parameter.actions=='stopTimer') {
    lInfo.logln("stopTimer for test play");
    if (Property.getNode('temporaryPlaying')!=null)
    	Property.getNode('temporaryPlaying').removeChild('rooms');

    var evt = new Event("sonos-controller-test-play-stopped", {});
    evt.raise();
  }
}