Ext.define('DSS.addon.SetVolume', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    checkVolume:null,
    timeSpanVolume:null,
    constructor : function() {
        this.checkVolume = Ext.create('Ext.form.field.Checkbox', {
                                         fieldLabel : "",
                                         align : 'middle',
                                       });

         var lblSetVolume  = Ext.create('Ext.form.Label',{
               text : _("Set volume to"),
               align : 'middle',
               cls : 'x-form-item-label',
               margin : '0 0 0 10'
         }); 
          
         this.timeSpanVolume  = Ext.create('Ext.form.field.Number', {
               fieldLabel : "",
               margin : '0 0 0 10',
               width : 50,
               step : 1,
               value : 0,
               minValue : 0,
               maxValue : 100
          });
          
         var lblSetVolume2  = Ext.create('Ext.form.Label',{
               text : "%",
               align : 'middle',
               cls : 'x-form-item-label',
               margin : '0 0 0 4'
          }); 
          
         var rowVolume = Ext.create('Ext.container.Container', {
               defaultType : 'numberfield',
               items : [this.checkVolume, lblSetVolume, this.timeSpanVolume, lblSetVolume2],
               layout : 'column',
               margin : '2 0 5 0',
               width : 530
           });
           
           Ext.apply(this, { items : [ rowVolume ] });
           this.callParent(arguments);
        },
    reset: function (){
            this.checkVolume.setValue(false);
            this.timeSpanVolume.setValue(0);
    },
    setValue:function (value) {
            var nSelectedPresetID = this.dssEditor.editControls.id.getValue();
         
            var sString = dss.ajaxSyncRequest('/json/property/query', {
                 'query' : '/scripts/sonos-controller/sonos-presets/'+nSelectedPresetID+'(*)'
             });
            var result = Ext.JSON.decode(sString);
            var arrayVolume = dss.parsePropertyQueryAnswer(result,[{name:'volumeSet', type:'simple'},
                                                                   {name:'volume', type:'simple'}]); 
         
            this.checkVolume.setValue(false);
            this.timeSpanVolume.setValue(0);
            if (arrayVolume != null && JSON.parse(arrayVolume[0].volumeSet)) {
              this.checkVolume.setValue(true);
              this.timeSpanVolume.setValue(arrayVolume[0].volume);
            }
        },
        isValid:function(){
            return true;
        },
        getValue : function(){
          var returnValue = new Object();
          
          returnValue.setVolume = this.checkVolume.checked;
          returnValue.volume = this.timeSpanVolume.getValue(); 
          
          return returnValue;
        }
});

Ext.define('DSS.addon.SelectPreset', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    getHeight:function () {
                 return this.iDefaultHeight;
    },
    
    height : '100%',
    grids : {},
    selectedRoomID : -1,
    presetID : -1,
    macPanel : null,
    arrayAllPresets:null,
    iDefaultWidth : 150,
    iDefaultHeight : 332,
    defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
       var fIsPassive=false;        
       if (record.get('passive')!=null)
         if (record.get('passive'))
           fIsPassive=true;
        var fHasNext=false;
        if (record.get('next') == true)  {
            fHasNext=true;
        }
        var fHasIcon=false;
        if (record.get('icon') != null) {
            fHasIcon=true;
        }        
           
       var sReturn='<table style="height:16px;"><tr>';
       var iColspaceCounter=3;
       if (fHasIcon) {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
       if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
       } 
       else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
       }
       if (fHasNext) {
            sReturn+='<td>&gt;</td>';
       }
       
       return sReturn +'</tr></table>';      
    },
    initStores : function(bLoadAllPresetRooms) {
       //if (Ext.data.StoreManager.lookup('selectpreset_l1') == null) 
       {
         var sString = dss.ajaxSyncRequest('/json/property/query', {
            'query' : '/scripts/sonos-controller/sonos-players/*(*)/*(*)/*(*)/*(*)'
             });
         var result = Ext.JSON.decode(sString);
         this.arrayActiveRooms = dss.parsePropertyQueryAnswer(result,[{name:'id', type:'simple'},
                                                                      {name:'sonosRoom', type:'simple'}, 
                                                                      {name:'ipAddress', type:'simple'},
                                                                      {name:'roomID',type:'simple'},
                                                                      {name:'notDiscovered',type:'simple'}]);    
         var actions = new Array();
         var arrayRooms = new Array();
         for ( var iIndex = 0; iIndex < this.arrayActiveRooms.length; iIndex++) {
           if (this.arrayActiveRooms[iIndex].roomID >0 && !JSON.parse(this.arrayActiveRooms[iIndex].notDiscovered)) {
                 var nRoomID = parseInt("" + this.arrayActiveRooms[iIndex].roomID);         
                 actions.push(new Object({name: dss.staticDataModel.getNameForZone(nRoomID),
                                          _id : nRoomID,
                                          icon: null, passive:false, next: true
                                        }));
                 arrayRooms.push(nRoomID);
           }
         }

         sString = dss.ajaxSyncRequest('/json/property/query', {
                                          'query' : '/scripts/sonos-controller/sonos-presets/*(*)'
                                          });
         result = Ext.JSON.decode(sString);
         this.arrayAllPresets = dss.parsePropertyQueryAnswer(result,[{name:'roomID',type:'simple'},
                                                                {name:'presetID', type:'simple'}]); 
         
         if (bLoadAllPresetRooms) {
           // adding rooms that are still stored in presets and not anymore have assigned players
           if (this.arrayAllPresets != null) {
             for ( var iIndex = 0; iIndex < this.arrayAllPresets.length; iIndex++) {
               var nRoomID = parseInt("" + this.arrayAllPresets[iIndex].roomID, 10);
               if (nRoomID > 0 && arrayRooms.indexOf(nRoomID) == -1) {
                 actions.push(new Object({name: dss.staticDataModel.getNameForZone(nRoomID),
                                                _id : nRoomID,
                                                icon: null, passive:true, next: true}));
                 arrayRooms.push(nRoomID);
               }
             }
           }
         }
        
         Ext.create('Ext.data.Store', {
             storeId : 'selectpreset_l1',
             fields : [ '_id', 'name', 'next', 'icon' ,'passive'],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
         });
         Ext.data.StoreManager.lookup('selectpreset_l1').add(actions);
       }
    },
    constructGridLvlPresets : function() {
        // for selected room test which preset are still available
        var arrayUsedPresets = new Array();
        if (this.selectedRoomID > 0 && this.arrayAllPresets != null) {
           for ( var iIndex = 0; iIndex < this.arrayAllPresets.length; iIndex++) {
             var nRoomID = parseInt("" + this.arrayAllPresets[iIndex].roomID, 10);
             var presetID = parseInt("" + this.arrayAllPresets[iIndex].presetID, 10);
             if (nRoomID == this.selectedRoomID && 
                 (this.presetID == -1 || (this.presetID>-1 && this.presetID != presetID)) // on edit we skip currently edited preset
                )
               arrayUsedPresets.push(presetID);
           }
        }
        
        if (Ext.data.StoreManager.lookup('selectpreset_list') != null) {
          Ext.data.StoreManager.lookup('selectpreset_list').removeAll();
        }
        else {
          Ext.create('Ext.data.Store', {
             storeId : 'selectpreset_list',
             fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
          });
        }
         
        var arrayPresets = new Array();
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 17), _id : 17, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(17)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 18), _id : 18, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(18)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 19), _id : 19, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(19)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 20), _id : 20, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(20)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 21), _id : 21, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(21)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 22), _id : 22, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(22)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 23), _id : 23, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(23)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 24), _id : 24, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(24)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 25), _id : 25, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(25)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 26), _id : 26, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(26)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 27), _id : 27, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(27)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 28), _id : 28, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(28)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 29), _id : 29, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(29)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 30), _id : 30, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(30)!=-1), next: false}));
        arrayPresets.push(new Object({name: dss.staticDataModel.getDefaultNameForScene(this.selectedRoomID, 4, 31), _id : 31, icon: '/framework/images/groupIcons/group_4_active.png', passive:(arrayUsedPresets.indexOf(31)!=-1), next: false}));
   
        Ext.data.StoreManager.lookup('selectpreset_list').add(arrayPresets);                     
     
        this.grids.lvlPresets = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('selectpreset_list'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlPresets.parent = this;

        this.grids.lvlPresets.on('itemclick', function(grid, record) {
            if (record.get('passive')) {
                this.getSelectionModel().deselect(record);
            }           
        });
        this.macPanel.add(this.grids.lvlPresets);

    },
    constructMacGrids : function() {
      var me = this;
      this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
          hideHeaders:true,
          height : this.iDefaultHeight,
          width : this.iDefaultWidth,
          autoScroll : true,
          viewConfig : {
              stripeRows : true
          },
          selModel : {
              mode : 'SINGLE'
          },
          columns : [ {
              sortable : false,
              hideable : false,
              dataIndex : 'name',
              flex : 1,
              renderer : this.defMacGridRenderer
          } ]
      });
      this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
      this.grids.lvl1.parent = this;

      this.grids.lvl1.on('itemclick', function(grid, record) {
          this.parent.macPanel.remove(this.parent.grids.lvlPresets);
          me.selectedRoomID = record.get('_id');
          this.parent.constructGridLvlPresets();
      }); 
    },
    constructor : function() {
        this.initStores(false);
        this.constructMacGrids();

        this.macPanel = Ext.create('Ext.panel.Panel', {
            border : '0',
            autoScroll : true,
            height : this.iDefaultHeight+2,
            layout : {
                type : 'hbox'
            },
            items : [ this.grids.lvl1 ],
            scroll : 'horizontal'
        });
        
        Ext.apply(this, {
            items : [ this.macPanel ]
        });

        this.callParent(arguments);
    },
    reset : function() {
      this.selectedRoomID = -1;
      this.presetID = -1;
      this.initStores(false);
      this.grids.lvl1.reconfigure(Ext.data.StoreManager.lookup('selectpreset_l1'));
      this.macPanel.remove(this.grids.lvlPresets); 


      var oSelectionLVL1 = this.grids.lvl1.getSelectionModel();
      oSelectionLVL1.select(0, true); 
      var selData = oSelectionLVL1.getSelection();
      if (selData != null && selData[0] != null) {
        this.selectedRoomID = selData[0].get("_id");
        this.presetID = -1;
        this.constructGridLvlPresets();       
      }
      
    },
    setValue : function(values) {
      this.initStores(true);
      this.grids.lvl1.reconfigure(Ext.data.StoreManager.lookup('selectpreset_l1'));
      this.macPanel.remove(this.grids.lvlPresets); 
      
      var nSelectedPresetID = this.dssEditor.editControls.id.getValue();
      if (nSelectedPresetID != null) {
        var sString = dss.ajaxSyncRequest('/json/property/query', {
                                          'query' : '/scripts/sonos-controller/sonos-presets/'+nSelectedPresetID+'(*)'
                                          });
        var result = Ext.JSON.decode(sString);
        var arrayPreset = dss.parsePropertyQueryAnswer(result,[{name:'roomID',type:'simple'},
                                                               {name:'presetID', type:'simple'}]); 
        if (arrayPreset != null) {
          var store = this.grids.lvl1.getStore();
          var foundRec = store.getAt(store.findExact('_id', parseInt("" + arrayPreset[0].roomID,10)));
          this.grids.lvl1.getSelectionModel().select(foundRec);   
         
          this.selectedRoomID = arrayPreset[0].roomID;
          this.presetID = arrayPreset[0].presetID;
          this.constructGridLvlPresets();
          var oRecordZone2 = this.grids.lvlPresets.store.find('_id', arrayPreset[0].presetID, 0, false,false,true);
          if (oRecordZone2 != -1)
            this.grids.lvlPresets.getSelectionModel().select(oRecordZone2);
        }
      }
    },
    isValid : function() {
       var bValid = false;
     
       var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection();
       if (this.grids.lvlPresets != null) {
         var oSelectionPreset = this.grids.lvlPresets.getSelectionModel().getSelection();
         if (oSelectionLVL1[0] != null && oSelectionPreset[0] != null)
           bValid = true;
       }
       return bValid;
    },
    getValue : function() {
      var returnValue = new Object();
      try {
        var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection();
        if (this.grids.lvlPresets != null) {
          var oSelectionPlaylist = this.grids.lvlPresets.getSelectionModel().getSelection();
          returnValue.roomID = oSelectionLVL1[0].get('_id');
          returnValue.presetID = oSelectionPlaylist[0].get('_id');
          //returnValue.presetName = oSelectionPlaylist[0].get('name');
        }
      }
      catch (e){}
      return returnValue;
    }    
});

Ext.define('DSS.addon.WhatToPlay', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    getHeight:function () {
       return this.iDefaultHeight;
    },

    height : '100%',
    grids : {'preset': {},
             'activity': {} 
            },
    nowFileType:-1, // -1: nothing, 0: current music, 1: current queue
    parentDialog:'',
    rowVolume:null,
    rowRepeat:null,
    rowRestart:null,
    checkVolume:null,
    timeSpanVolume:null,
    checkRepeat:null,
    timeSpanRepeat:null,
    checkRestart:null,
    lblNowPlayed:null,
    selectedSong:null,
    selectedQueue:null,
    dialogPreset: false,
    gridQueue:null,
    macPanel : null,
    arrayActiveRooms : null,
    nSelectedRoom : null,
    sSelectedRoomIP : "",
    iDefaultWidth : 150,
    iDefaultHeight : 290,
    nActionType: -1,
    txt2Speech : null,
    comboTextLang : null,
    comboTextVoice : null,
    bIsRadio:false,
    arrayMediaLibrary : null,
    arraySpeechSettings : null,
    btnTestPlay:null,
    testPlayStatusPlaying:false,
    testPlayStopSubscriptID:0,
    testPlayCreateSubscriptID:0,
    playListStoredSubscriptID:0,
    getMediaLibSubscriptID:0,
    t2sCreatedObj : null,
    t2sOriginalGUID: "", //value of stored t2sOriginalGUID when editing t2s
    t2sGUIDFolder:"",  // folder GUID is stored inside GetMediaLibrary under branch Text to speech
    mediaGroupsSub:null,
    bRestartRowIsEnabled:false,
    bVolumeRowIsEnabled:false,
    /* Prepare text for user when no cloud data is available*/
    getRemoteErrorText : function(pObject) {
      var sReturnText = "";
      if (pObject == null || JSON.stringify(pObject) == '{}' ) {
        var sString = dss.ajaxSyncRequest('/json/property/query', {
                            'query' : '/scripts/sonos-controller/media-service(isConnectivityAvailable)'
                        });           
        var result = Ext.JSON.decode(sString);
        oResultObject=dss.parsePropertyQueryAnswer(result,[{name:'isConnectivityAvailable',type:'simple'}]);

        if (oResultObject != null && oResultObject[0] != null) {
          if (oResultObject[0].isConnectivityAvailable != null && 
              !JSON.parse(oResultObject[0].isConnectivityAvailable)) {
            sReturnText = _('To use this feature, the my.digitalSTROM app must be configured first.');   
          }
          else {
            var sString = dss.ajaxSyncRequest('/json/property/query', {
                                'query' : '/scripts/sonos-controller/media-service(isServiceConnected)'
                            });           
            var result = Ext.JSON.decode(sString);
            oResultObject=dss.parsePropertyQueryAnswer(result,[{name:'isServiceConnected',type:'simple'}]);
           
            if ((oResultObject != null && oResultObject[0] != null && oResultObject[0].isServiceConnected != null && 
                 !JSON.parse(oResultObject[0].isServiceConnected)
                ) 
               ) {
                 sReturnText = _('This feature is not available because the connection to the my.digitalSTROM service is interrupted. Please check your internet connection and try reloading addon again.');    
            }
          }
        }
      }
      return sReturnText;
    },
    preparePlayButton : function(bEnable) {
      if (!this.dialogPreset && this.btnTestPlay != null) {
        if (bEnable)
          this.btnTestPlay.enable();
        else
          this.btnTestPlay.disable();
      }
    },
    
    /** 
     @brief Function test if valid item is selected(bValidSelection) and 
            if this file is singleFile (bSingleFileSelected)
      
     @return  
    */ 
    checkIfSelectedItemIsSingleFile : function (bTestText2SpeechParams) {
       var returnInfo = {bValidSelection:false, bSingleFileSelected:false}; 
        
       var oSelectionLVL1 = this.grids[this.parentDialog].lvl1.getSelectionModel().getSelection();
       if (oSelectionLVL1[0] != null) {   
         switch(oSelectionLVL1[0].get('_id')) {
           case 0:
            if (this.nowFileType == 0 && this.selectedSong != null) {
              returnInfo.bValidSelection = true; 
              returnInfo.bSingleFileSelected = true; 
              if (this.selectedSong.isRadio != null)
                returnInfo.bSingleFileSelected = !this.selectedSong.isRadio; 
            }
            else  
              if (this.nowFileType == 1 && this.selectedQueue != null) 
                returnInfo.bValidSelection = true; 
           break; 
           
           case 1: // playlists
             oSelectionPlaylist = this.grids[this.parentDialog].lvlPlaylist.getSelectionModel().getSelection();
             if (oSelectionPlaylist != null && oSelectionPlaylist.length > 0) {
               returnInfo.bValidSelection = true; 
             }
           break; 

           case 2: // favorites
             oSelectionFavorites = this.grids[this.parentDialog].lvlFavorites.getSelectionModel().getSelection();
             if (oSelectionFavorites != null && oSelectionFavorites.length > 0) {
               returnInfo.bValidSelection = true; 
               // check if single file
               if (!this.dialogPreset) {
                 returnInfo.bSingleFileSelected = oSelectionFavorites[0].get('isSingleTrack');
               }
             }
           break; 

           case 3: // Media Library
             // if selected file from last level
             oSelectionMedia = this.grids[this.parentDialog].lvlMediaFiles.getSelectionModel().getSelection();
             if (oSelectionMedia != null && oSelectionMedia.length > 0) {
               returnInfo.bValidSelection = true; 
               returnInfo.bSingleFileSelected = true;
             }
             else {
               // if selected file from sub group level, where can also be files
               oSelectionMedia = this.grids[this.parentDialog].lvlMediaGroupsSub.getSelectionModel().getSelection();
               if (oSelectionMedia != null && oSelectionMedia.length > 0) {
                 // test if selected is file, not folder
                 if (!oSelectionMedia[0].get('next')) {
                   returnInfo.bValidSelection = true; 
                   returnInfo.bSingleFileSelected = true;
                 }
               }
             }
           break; 

           case 4: // Text2Speech
             if (bTestText2SpeechParams) {
                 if (this.txt2Speech.getValue() != "" && this.comboTextLang.getValue != "" && this.comboTextVoice.getValue != "") {
                   returnInfo.bValidSelection = (this.txt2Speech.getValue().trim().length <= this.arraySpeechSettings.maxTextLength);
                     
                   if (returnInfo.bValidSelection)
                     returnInfo.bValidSelection = (this.t2sCreatedObj.error == ""); 
                   
                   returnInfo.bSingleFileSelected = true;
                 }
             }
             else
               returnInfo.bSingleFileSelected = true;
           break; 
           
           case 5: // command
             oSelectionCommand = this.grids[this.parentDialog].lvlCommands.getSelectionModel().getSelection();
             if (oSelectionCommand != null && oSelectionCommand.length > 0) {
               returnInfo.bValidSelection = true; 
             }
             bCheckFileLength = false;
           break; 
         }
       }
       
       return returnInfo;
    },

    /** 
      @brief Function enables/disables "Restart previous music once finished" control
             If activity has uknown execution length this option is disabled
             
      @return  
    */ 
    handleRepeatPreviusMusicControl : function() {
        if (!this.dialogPreset) { //setup control only for Activity dialog
            var bDisableControl = true;
            var nTime = parseInt("" +this.timeSpanRepeat.getValue(), 10);
            if (this.checkRepeat.checked && nTime > 0) {
              // if Repeat music is checked and set, we don't need to test song length
              bDisableControl = false;
            }
            else {
                // test what trigger value is selected
                // if "Security" item is selected, we also don't need to check song length
                if (this.dssEditor.editControls.triggers != null && 
                    this.dssEditor.editControls.triggers.getValue().length>0 &&
                    ( // if selected Alarm1..Alarm4,Panic                                                                                   
                      (this.dssEditor.editControls.triggers.getValue()[0].type == 'zone-scene' && 
                       predefinedUnduEvents.indexOf(this.dssEditor.editControls.triggers.getValue()[0].scene) > -1
                      ) ||
                      ( // or if selected Fire
                        this.dssEditor.editControls.triggers.getValue()[0].type == 'state-change' &&
                        this.dssEditor.editControls.triggers.getValue()[0].name == 'fire'
                      )
                    )
                   ) { //
                   bDisableControl = false;    
                }
                else  {
                    // length of Activity can be known only if selected What To Play is single file
                    var bSelectedData = this.checkIfSelectedItemIsSingleFile(false);
                    if (bSelectedData.bSingleFileSelected)
                      bDisableControl = false; 
                }
            }
            
            if (bDisableControl) {
              this.rowRestart.disable();
              bRestartRowIsEnabled = false;
            }
            else {
              this.rowRestart.enable();
              bRestartRowIsEnabled = true;
            }
        }
    },
    preparePlayExtraControls : function(nCommand) {
      switch(nCommand) {
        case -1: // enable all
          this.rowVolume.enable();
          this.bVolumeRowIsEnabled = true;
          if (!this.dialogPreset) {
            this.rowRepeat.enable();
            this.rowRestart.enable();
          }
        break;
        
        case 1:  // stop
          this.rowVolume.disable();
          this.bVolumeRowIsEnabled = false;
          if (!this.dialogPreset) {
            this.rowRepeat.disable();
            this.rowRestart.disable();
          }
        break;

        case 2:  // play
        case 5:  // unmute
          this.rowVolume.enable();
          this.bVolumeRowIsEnabled = true;
          if (!this.dialogPreset) {
            this.rowRepeat.disable();
            this.rowRestart.disable();
          }
        break;

        case 3:  // pause
        case 4:  // mute
          this.rowVolume.disable();
          this.bVolumeRowIsEnabled = false;
          if (!this.dialogPreset) {
            this.rowRepeat.disable();
            this.rowRestart.disable();
          }
        break;
      }
    },
    defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
       var fIsPassive=false;        
       if (record.get('passive')!=null)
         if (record.get('passive'))
           fIsPassive=true;
        var fHasNext=false;
        if (record.get('next') == true)  {
            fHasNext=true;
        }
           
       var sReturn='<table style="height:16px;"><tr>';
       var iColspaceCounter=3;
       if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
       } 
       else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
       }
       if (fHasNext) {
            sReturn+='<td>&gt;</td>';
       }
       
       return sReturn +'</tr></table>';      
    },
    initLvl1 : function() {
       if (Ext.data.StoreManager.lookup('whattoplay_l1Store_'+this.parentDialog) == null) {
         var actions =[{ name : _('Now Playing'),
                         _id : 0,
                         next : true,
                         icon : null,
                         passive: false
                       }, {
                           name : _('Sonos Playlist'),
                           _id : 1,
                           next : true,
                           icon : null,
                           passive: false
                       }, {
                           name : _('Sonos Favorites'),
                           _id : 2,
                           next : true,
                           icon : null,
                           passive: false
                       }];
            if (!this.dialogPreset) {
              actions.push({name : _('Library'),
                            _id : 3,
                            next : true,
                            icon : null,
                            passive: false
                          });
              actions.push({name : _('Text to speech'),
                            _id : 4,
                            next : true,
                            icon : null,
                            passive: false
                           });
              actions.push({name : _("Command"),
                            _id : 5,
                            next : true,
                            icon : null,
                            passive:false
                           });
            }
                       
            Ext.create('Ext.data.Store', {
                storeId : 'whattoplay_l1Store_'+this.parentDialog,
                fields : [ '_id', 'name', 'next', 'icon' ,'passive'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('whattoplay_l1Store_'+this.parentDialog).add(actions);
       }
    },
    initStores : function() {
try{     
      var sString = dss.ajaxSyncRequest('/json/property/query', {'query' : '/scripts/sonos-controller/sonos-players/*(*)/*(*)/*(*)/*(*)'});
      var result = Ext.JSON.decode(sString);
      var arrayTmp = dss.parsePropertyQueryAnswer(result,[{name:'id', type:'simple'},
                                                           {name:'sonosRoom', type:'simple'}, 
                                                           {name:'ipAddress', type:'simple'},
                                                           {name:'roomID',type:'simple'},
                                                           {name:'notDiscovered',type:'simple'}]);    
      var me = this;
      this.arrayActiveRooms = [];
      var arrayPlayRooms = new Array();
      var sSonosIP = "";
      for ( var iIndex = 0; iIndex < arrayTmp.length; iIndex++) {
         var roomID = parseInt("" + arrayTmp[iIndex].roomID, 10); 
         if (roomID > 0 && !JSON.parse(arrayTmp[iIndex].notDiscovered)) {
           if (sSonosIP == "") {
             sSonosIP = arrayTmp[iIndex].ipAddress;
           }
           arrayTmp[iIndex].roomName = dss.staticDataModel.getNameForZone(roomID);
           arrayTmp[iIndex].sonosRoom = unescape(arrayTmp[iIndex].sonosRoom);
           this.arrayActiveRooms.push(arrayTmp[iIndex]);
           var tmpData = new Object({'_id':arrayTmp[iIndex].id,
                                     'name':arrayTmp[iIndex].roomName,
                                     'next':true,
                                     'passive' : false,
                                     'playerIP' : arrayTmp[iIndex].ipAddress 
                                    });      
           arrayPlayRooms.push(tmpData);     
         }
      }
      
      if (Ext.data.StoreManager.lookup('whattoplay_commands') == null) {
                                   
         Ext.create('Ext.data.Store', {
             storeId : 'whattoplay_commands',
             fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
         });

         var arrayCommands = new Array({name : _('Stop'),
                                         _id : 1,
                                         next : false,
                                         icon : null,
                                         passive: false
                                        },
                                        {name : _('Play'),
                                         _id : 2,
                                         next : false,
                                         icon : null,
                                         passive: false
                                        },
                                        {name : _('Pause'),
                                         _id : 3,
                                         next : false,
                                         icon : null,
                                         passive: false
                                        },
                                        {name : _('Mute'),
                                         _id : 4,
                                         next : false,
                                         icon : null,
                                         passive: false
                                        },
                                        {name : _('Unmute'),
                                         _id : 5,
                                         next : false,
                                         icon : null,
                                         passive: false
                                        });
         
         Ext.data.StoreManager.lookup('whattoplay_commands').add(arrayCommands);                     
       }
       
      if (!this.dialogPreset) { 
         if (Ext.data.StoreManager.lookup('whattoplay_rooms') == null) {
           Ext.create('Ext.data.Store', {
               storeId : 'whattoplay_rooms',
               fields : [ '_id', 'name', 'next', 'icon', 'passive', 'playerIP'],
               proxy : {
                   type : 'memory',
                   reader : {
                       type : 'json',
                       root : 'items'
                   }
               }
           });
         }
         else
           Ext.data.StoreManager.lookup('whattoplay_rooms').removeAll();
         
         if (Ext.data.StoreManager.lookup('whattoplay_mediafiles') == null) {
           Ext.create('Ext.data.Store', {
               storeId : 'whattoplay_mediafiles',
               fields : [ '_id', 'name', 'next', 'icon', 'passive'],
               proxy : {
                   type : 'memory',
                   reader : {
                       type : 'json',
                       root : 'items'
                   }
               },
               sorters: [{property: 'name',direction: 'ASC'}]
           });
         }
         else
           Ext.data.StoreManager.lookup('whattoplay_mediafiles').removeAll();
         
         if (Ext.data.StoreManager.lookup('whattoplay_txt2speech_voice') == null) {
           Ext.create('Ext.data.Store', {
               storeId : 'whattoplay_txt2speech_voice',
               fields : [ 'id', 'name'],
               proxy : {
                   type : 'memory',
                   reader : {
                       type : 'json',
                       root : 'items'
                   }
               }
           });
         }
         else
           Ext.data.StoreManager.lookup('whattoplay_txt2speech_voice').removeAll();
         
         if (Ext.data.StoreManager.lookup('whattoselect_rooms') == null) {
           Ext.create('Ext.data.Store', {
               storeId : 'whattoselect_rooms',
               fields : [ 'roomID', 'roomName', 'passive'],
               proxy : {
                   type : 'memory',
                   reader : {
                       type : 'json',
                       root : 'items'
                   }
               },
               sorters: [{property: 'roomName',direction: 'ASC'}]
           });
         }
         else
           Ext.data.StoreManager.lookup('whattoselect_rooms').removeAll();
         
         Ext.data.StoreManager.lookup('whattoplay_rooms').add(arrayPlayRooms);   
         Ext.data.StoreManager.lookup('whattoselect_rooms').add(this.arrayActiveRooms);   
       }
       this.constructActivityFields();
                                                               
       Ext.create('Ext.data.Store', {
             storeId : 'whattoplay_queue',
             fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
             proxy : {
                 type : 'memory',
                 reader : {
                     type : 'json',
                     root : 'items'
                 }
             }
         });
} 
catch (e){
  // alert("WtP initCache "+e.message);
}          
    },
    fillMediaFilesGrid : function (sGroupGUID) {
      var store = Ext.data.StoreManager.lookup('whattoplay_mediafiles');
      store.removeAll();
      
      var selectedFiles = null;
      for ( var iIndex = 0; iIndex < this.arrayMediaLibrary.length; iIndex++) {
        var selectedObj = this.arrayMediaLibrary[iIndex];
        if (sGroupGUID != null && sGroupGUID == selectedObj.MediaLibraryTreeBranchGUID) {
          selectedFiles = selectedObj.MediaFileList;
          break;
        }
      }
      
      if (selectedFiles != null) {
        var mediaFiles = new Array();
        for ( var iIndex = 0; iIndex < selectedFiles.length; iIndex++) {
          var selectedObj = selectedFiles[iIndex];
          
          if (selectedObj != null) {
            var tmpData = new Object({'_id':selectedObj.MediaLibraryTreeMediaFileGUID,
                                      'name':selectedObj.MediaFileName,
                                      'next':false,
                                      'passive' : false,
                                     });      
            mediaFiles.push(tmpData);     
          }
        }
        store.add(mediaFiles);   
      }
    },
    fillMediaSubGrid : function (sGroupGUID) {
      var store = Ext.data.StoreManager.lookup('whattoplay_mediagroups_sub');
      store.filter('masterGroup', sGroupGUID);
    },
    updatePresetName : function(sNewName) {
      if (this.dialogPreset && sNewName != "") { //&& this.dssEditor.editControls.audioName.getValue() == null 
        this.dssEditor.editControls.audioName.setValue(sNewName);   
      } 
    }, 
    getSonosDeviceMusic : function () {
        var me = this;
        
        me.gridQueue.setVisible(false);
        me.lblNowPlayed.setVisible(true);
           
        if ((me.dialogPreset && me.nSelectedRoom > -1) ||
            (!me.dialogPreset)) {
               var waitDialog = new Ext.LoadMask(Ext.getBody(), {msg:_('Please wait, reading from Sonos device ...')});
               waitDialog.show();
              
               var sIP = "";
               if (me.dialogPreset) {
                 for ( var iIndex = 0; iIndex < me.arrayActiveRooms.length; iIndex++) {
                   if (me.arrayActiveRooms[iIndex].roomID == me.nSelectedRoom) {
                     sIP = me.arrayActiveRooms[iIndex].ipAddress;
                     break;
                   }
                 }
               }
               else {
                 sIP = me.sSelectedRoomIP;
               }
               
               dss.ajaxAssyncRequestWithoutAnswer('/json/event/raise',{name:'sonos-controller.getdata',
                                                                       parameter:'actions=getSonosTrack;value='+Ext.JSON.encode(sIP)});
               
               var iSubscriptID = Math.floor(Math.random() * 100000000000);
               dss.ajaxSyncRequest('/json/event/subscribe', {
                   subscriptionID : iSubscriptID,
                   name : 'sonos-discover-return-sonos-track'
               });

               dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                   subscriptionID : iSubscriptID,
                   timeout : 3*1000
               }, function(sValue) {
                   dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                       subscriptionID : iSubscriptID,
                       name : 'sonos-discover-return-sonos-track'
                   });

                   var oValue=JSON.parse(sValue);
                   var bWarnOnlySong = false;
                   if (oValue != null && oValue.result != null && oValue.result.events[0] != null && oValue.result.events[0].properties != null) {
                     me.selectedSong = JSON.parse(unescape(oValue.result.events[0].properties.returnValue));
                     var sTitle = _("No music");
                     if (me.selectedSong != null && 
                         me.selectedSong instanceof Object &&
                         me.selectedSong.title != "" && 
                         me.selectedSong.url != "") {
                       sTitle = _("Song: ");
                       if (me.selectedSong.isRadio)
                         sTitle = _("Radio: ");
                       
                       me.bIsRadio = me.selectedSong.isRadio; 
                       
                       if (me.selectedSong.title != "")
                         sTitle += me.selectedSong.title;
                       if (me.selectedSong.artist != "")
                         sTitle += " ("+me.selectedSong.artist+")";
                       me.selectedSong.changed = true;
                       
                       me.updatePresetName(me.selectedSong.title);
                     }
                     else
                       me.selectedSong = null;
                     me.lblNowPlayed.setText(sTitle); 
                     
                     me.nowFileType = 0;
                   }
                   
                   if (!me.dialogPreset)
                     me.handleRepeatPreviusMusicControl();
                   
                   waitDialog.hide();
                   if (bWarnOnlySong)
                     Ext.MessageBox.alert(_('Info'), _("Only music with defined length allowed"), null);
               });   
             }     
    },  
    getSonosDeviceQueue : function () {
       var me = this;
       
        me.gridQueue.setVisible(false);
        me.lblNowPlayed.setVisible(false);
       
       if ((me.dialogPreset && me.nSelectedRoom > -1) || (!me.dialogPreset)) {
        var waitDialog = new Ext.LoadMask(Ext.getBody(), {msg:_('Please wait, reading from Sonos device ...')});
        waitDialog.show();
       
        var sIP = "";
        if (me.dialogPreset) {
          for ( var iIndex = 0; iIndex < me.arrayActiveRooms.length; iIndex++) {
            if (me.arrayActiveRooms[iIndex].roomID == me.nSelectedRoom) {
              sIP = me.arrayActiveRooms[iIndex].ipAddress;
              break;
            }
          }
        }
        else {                                                             
          sIP = me.sSelectedRoomIP;
        }


        var sValue=dss.ajaxSyncRequest('/json/event/raise',{name:'sonos-controller.getdata',
                                                            parameter:'actions=getSonosQueue;value='+Ext.JSON.encode(sIP)});
        
        var iSubscriptID = Math.floor(Math.random() * 100000000000);
        dss.ajaxSyncRequest('/json/event/subscribe', {
            subscriptionID : iSubscriptID,
            name : 'sonos-discover-return-sonos-queue'
        });

        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
            subscriptionID : iSubscriptID,
            timeout : 5*1000
        }, function(sValue) {
            var oValue=JSON.parse(sValue);
            if (oValue != null && oValue.result != null && oValue.result.events[0] != null && oValue.result.events[0].properties != null) {
              me.selectedQueue = JSON.parse(unescape(oValue.result.events[0].properties.returnValue));
              if (me.selectedQueue != null) {
                Ext.data.StoreManager.lookup('whattoplay_queue').removeAll();
               
                if (me.selectedQueue.length > 0) {
                  var arrayFiles  = new Array();
                  for ( var iIndex = 0; iIndex < me.selectedQueue.length; iIndex++) {
                    var pos = (iIndex+1);
                    var tmpObj = new Object({_id:iIndex, 
                                             name:pos+". "+unescape(me.selectedQueue[iIndex].title)});
                    arrayFiles.push(tmpObj);
                  }
                  Ext.data.StoreManager.lookup('whattoplay_queue').add(arrayFiles);  
                  me.gridQueue.setVisible(true);
                  me.selectedQueue.changed = true;
                }
                else {
                  me.lblNowPlayed.setText(_("Active Queue is empty.")); 
                  me.lblNowPlayed.setVisible(true);
                }
                me.nowFileType = 1;
              }
            }
            if (!me.dialogPreset)
              me.handleRepeatPreviusMusicControl();
            waitDialog.hide();
         
            dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                subscriptionID : iSubscriptID,
                name : 'sonos-discover-return-sonos-queue'
            });
        });                
      }
    },
    constructGridLvlNowPlaying : function() {
try{     
      var me = this;
       
      if (!this.dialogPreset)
      {
        this.grids[this.parentDialog].lvlNowRooms = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : me.iDefaultHeight,
            width : 160,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_rooms'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : me.defMacGridRenderer
            } ]
        });
        this.grids[this.parentDialog].lvlNowRooms.parent = this;
        this.macPanel.add(this.grids[this.parentDialog].lvlNowRooms);
      }

      this.lblNowPlayed = Ext.create('Ext.form.Label',{
                                          text : "",
                                          margin : '0 0 2 20',
                                          cls : 'x-form-item-label',
                                          id: 'lblNowPlayed'
                                       });
      this.lblNowPlayed.setVisible(false);
      
      this.gridQueue = Ext.create('Ext.grid.Panel', {
             hideHeaders:true,
             autoScroll : true,
             width:400,
             height:230,
             margin : '5 0 0 20',
             store : Ext.data.StoreManager.lookup('whattoplay_queue'),
             viewConfig : {
                 stripeRows : true
             },
             selModel : {
                 mode : 'NONE'
             },
             columns : [ {
                 sortable : false,
                 hideable : false,
                 flex : 1,
                 renderer : this.defMacGridRenderer
             } ]
         }); 
      this.gridQueue.setVisible(false);
      this.gridQueue.on('itemclick', function(grid, record) {
          this.getSelectionModel().deselect(record);
      });
      if (!this.dialogPreset)
        this.gridQueue.setHeight(160);
      else
        this.gridQueue.setHeight(230);
        
       
      var btnGet = Ext.create('Ext.Button', {
             text: _('Get song'),
             margin : '0 0 2 20',
             handler: function() {
     
                if (me.dialogPreset) { 
                  me.nSelectedRoom = me.dssEditor.editControls.triggerPreset.selectedRoomID;
                  if (me.nSelectedRoom > -1)
                    me.getSonosDeviceMusic();  
                  else
                    Ext.MessageBox.alert(_('Info'), _("Please first select room on trigger tab, to get current Sonos song"), null);
                }
                else {
                  me.getSonosDeviceMusic();
                }
             }   
         });
      var btnQueue = Ext.create('Ext.Button', {
             text: _('Get Active queue'),
             margin : '0 0 2 20',
             handler: function() {
                if (me.dialogPreset) { 
                  me.nSelectedRoom = me.dssEditor.editControls.triggerPreset.selectedRoomID;
                  if (me.nSelectedRoom > -1)
                    me.getSonosDeviceQueue();  
                  else
                    Ext.MessageBox.alert(_('Info'), _("Please first select room on trigger tab, to get current Sonos Queue"), null);
                }
                else {
                  me.getSonosDeviceQueue();
                }
             }
         });
      var allButtons = Ext.create('Ext.container.Container', {
            defaultType : 'numberfield',
            items : [  btnGet, btnQueue ],
            layout: {type: 'hbox'},
            margin : '5 0 5 0',
            width : 600 });

      this.grids[this.parentDialog].lvlNowPlaying = Ext.create('Ext.container.Container', {
            defaultType : 'numberfield',
            items : [ allButtons, me.lblNowPlayed, me.gridQueue ], 
            layout: {type: 'vbox'},
            margin : '5 0 5 0',
            width : 440
       });

                      
      if (!this.dialogPreset) {
        this.grids[this.parentDialog].lvlNowRooms.on('itemclick', function(grid, record) {
          var oSelectionFavorites = this.getSelectionModel().getSelection();
          me.nSelectedRoom = oSelectionFavorites[0].get('_id');  
          me.sSelectedRoomIP = oSelectionFavorites[0].get('playerIP');  
          me.macPanel.add(me.grids[me.parentDialog].lvlNowPlaying);
          
          me.lblNowPlayed.setVisible(false);
          me.lblNowPlayed.setText("");
          me.selectedSong = null;
          
          me.gridQueue.setVisible(false);
          me.selectedQueue = null;
          me.handleRepeatPreviusMusicControl();
        });
      }
      else  {
        //this.grids[this.parentDialog].lvlNowPlaying.setHeight(600);
        this.macPanel.add(this.grids[this.parentDialog].lvlNowPlaying);
      }
}        
catch (e){
//   alert("WtP initCache "+e.message);
}           
    },
    fillText2SpeechLanguage : function(me, sSelection) {
       //me.t2sLangID = sSelection;
     
       Ext.data.StoreManager.lookup('whattoplay_txt2speech_voice').removeAll();
     
       if (me.arraySpeechSettings != null) {
         var arrayPersons = new Array();
         if (me.arraySpeechSettings.config != null && me.arraySpeechSettings.config.length > 0) {
           for (var i=0;i<me.arraySpeechSettings.config.length;i++) {
             if (sSelection == me.arraySpeechSettings.config[i].LanguageCode) {
               if (me.arraySpeechSettings.config[i].VoiceNameList != null) {
                 for (var j=0;j<me.arraySpeechSettings.config[i].VoiceNameList.length;j++) {
                   arrayPersons.push({'id': me.arraySpeechSettings.config[i].VoiceNameList[j].VoiceId, 'name': me.arraySpeechSettings.config[i].VoiceNameList[j].VoiceName}); 
                 }
               }
               break;
             } 
           }
         }
         Ext.data.StoreManager.lookup('whattoplay_txt2speech_voice').add(arrayPersons);
         if (arrayPersons.length > 0) {
            me.comboTextVoice.setValue(arrayPersons[0].id);
         }   
       }   
     
    },
    constructGridLvlText2Speech : function() {
try{   
      var me = this; 
      this.preparePlayButton(true);
 
      this.comboTextLang  = Ext.create('Ext.form.field.ComboBox', {
                  store: Ext.data.StoreManager.lookup('whattoplay_txt2speech_lang'),           
                  queryMode: 'local',
                  displayField: 'name',
                  margin : '5 0 0 0',
                  valueField: 'id',                    
                  fieldLabel :  _('Language'),
                  labelWidth : 120,
                  width : 400,
                  listeners:{
                     'select': function(objCombo){
                        me.fillText2SpeechLanguage(me, objCombo.getValue());
                     }
                  }
      });
      
      this.comboTextVoice  = Ext.create('Ext.form.field.ComboBox', {
                  store: Ext.data.StoreManager.lookup('whattoplay_txt2speech_voice'),           
                  queryMode: 'local',
                  displayField: 'name',
                  valueField: 'id',     
                  margin : '5 0 0 0',               
                  fieldLabel :  _('Voice'),
                  labelWidth : 120,
                  width : 400,
                  listeners:{
                     'select': function(objCombo){
//                        me.t2sVoiceName = objCombo.getValue();
                     }
                  }
              });

      // setting default language picker
      if (dss.staticDataModel.activeLanguage != null) {
        this.comboTextLang.setValue(dss.staticDataModel.activeLanguage.replace('_','-'));
        this.fillText2SpeechLanguage(this, this.comboTextLang.getValue());
      } 
              
       this.txt2Speech  = Ext.create('Ext.form.field.TextArea', {
            fieldLabel : _("Text to speech"),
            labelWidth : 120,
            margin : '5 0 0 0',
            value : "",
            width: 600,
            height:140
       });
       
              
      this.grids[this.parentDialog].lvlText2Speech = Ext.create('Ext.container.Container', {
            defaultType : 'numberfield',
            items : [ this.comboTextLang, this.comboTextVoice, this.txt2Speech], 
            layout: {type: 'vbox'},
            margin : '5 0 0 10',
            width : 600,
            height: 200,
       });
       
       var bDisable = true;
       if (this.arraySpeechSettings != null && JSON.stringify(this.arraySpeechSettings) != '{}' ) {
         this.txt2Speech.maxLength = this.arraySpeechSettings.maxTextLength;
         var bDisable = false;
       }
       
       if (bDisable) {
         this.grids[this.parentDialog].lvlText2Speech.disable();
         this.preparePlayButton(false);
       }

       this.macPanel.add(this.grids[this.parentDialog].lvlText2Speech);
}        
catch (e){
   //alert("WtP constructGridLvlText2Speech "+e.message);
}           
    },
    constructGridLvlPlaylist : function() {
        this.grids[this.parentDialog].lvlPlaylist = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_playlists'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids[this.parentDialog].lvlPlaylist.parent = this;

        this.grids[this.parentDialog].lvlPlaylist.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            } 
            else {
              this.parent.preparePlayButton(true);
              this.parent.updatePresetName(record.get('name'));
            }
            if(!this.parent.dialogPreset) {
              this.parent.handleRepeatPreviusMusicControl();
            }
        });
        this.macPanel.add(this.grids[this.parentDialog].lvlPlaylist);

    },
    constructGridLvlFavorites : function() {

        this.grids[this.parentDialog].lvlFavorites = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_favorites'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids[this.parentDialog].lvlFavorites.parent = this;

        this.grids[this.parentDialog].lvlFavorites.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            } 
            else {
              this.parent.preparePlayButton(true);
              this.parent.updatePresetName(record.get('nameShort'));
            }
            if(!this.parent.dialogPreset) {
              this.parent.handleRepeatPreviusMusicControl();
            }
        });
        this.macPanel.add(this.grids[this.parentDialog].lvlFavorites);

    },
    constructGridLvlMediaLib : function() {
try {     
       var me = this;   
       this.grids[this.parentDialog].lvlMediaGroups = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 170,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_mediagroups'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        
       this.grids[this.parentDialog].lvlMediaGroups.parent = this;
       this.grids[this.parentDialog].lvlMediaGroups.on('itemclick', function(grid, record) {
          if (record != null && record.get('_id') != null) {
            if (record.get('hasSubGroup') != "") { 
              me.fillMediaSubGrid(record.get('_id'));
              me.grids[me.parentDialog].lvlMediaGroupsSub.show();
              me.grids[me.parentDialog].lvlMediaFiles.hide();
            }
            else {
              // no sub folders
              me.grids[me.parentDialog].lvlMediaGroupsSub.hide();
              me.grids[me.parentDialog].lvlMediaFiles.setWidth(454);
              me.grids[me.parentDialog].lvlMediaFiles.show();
              me.fillMediaFilesGrid(record.get('_id'));
            }
          }
          me.preparePlayButton(false);
          me.handleRepeatPreviusMusicControl();
        });
       this.macPanel.add(this.grids[this.parentDialog].lvlMediaGroups);

       this.grids[this.parentDialog].lvlMediaGroupsSub = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 170,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_mediagroups_sub'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
       this.grids[this.parentDialog].lvlMediaGroupsSub.parent = this;
       this.grids[this.parentDialog].lvlMediaGroupsSub.on('itemclick', function(grid, record) {
          if (record != null && record.get('_id') != null) {
            me.grids[me.parentDialog].lvlMediaFiles.setWidth(284);
            me.grids[me.parentDialog].lvlMediaFiles.show();
            me.fillMediaFilesGrid(record.get('_id'));
            me.preparePlayButton(!record.get('next'));
          }
          me.handleRepeatPreviusMusicControl();
        });
       this.macPanel.add(this.grids[this.parentDialog].lvlMediaGroupsSub);
       me.grids[me.parentDialog].lvlMediaGroupsSub.hide();
        
       Ext.data.StoreManager.lookup('whattoplay_mediafiles').removeAll();
       this.grids[this.parentDialog].lvlMediaFiles = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 284,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_mediafiles'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
       this.grids[this.parentDialog].lvlMediaFiles.parent = this;
       this.grids[this.parentDialog].lvlMediaFiles.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }  
            else
              this.parent.preparePlayButton(true);
            this.parent.handleRepeatPreviusMusicControl();
       });
       this.macPanel.add(this.grids[this.parentDialog].lvlMediaFiles);
       me.grids[me.parentDialog].lvlMediaFiles.hide();
}
catch (e){
  // alert("WtP constructGridLvlMediaLib "+e.message);
}             
    },
    constructGridLvlCommands : function() {
        var me = this;
        this.grids[this.parentDialog].lvlCommands = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            selModel : {
                mode : 'SINGLE'
            },
            store : Ext.data.StoreManager.lookup('whattoplay_commands'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids[this.parentDialog].lvlCommands.parent = this;

        this.grids[this.parentDialog].lvlCommands.on('itemclick', function(grid, record) {
            if (record.get('_id') == -1) {
                this.getSelectionModel().deselect(record);
            }           
            else
              me.preparePlayExtraControls(record.get('_id'));
        });
        this.macPanel.add(this.grids[this.parentDialog].lvlCommands);

    },
    constructActivityFields : function() {
       /* VOLUME */      
try {            
       var me = this;  
       var rowRestart = null;
       this.checkVolume = Ext.create('Ext.form.field.Checkbox', {
                                      fieldLabel : "",
                                      align : 'middle',
                                      listeners:{
                                        'change': function(checkbox, newVal, oldVal){
                                                   }
                                      }                                      
                                    });

       var lblSetVolume  = Ext.create('Ext.form.Label',{
            text : _("Set volume to"),
            align : 'middle',
            cls : 'x-form-item-label',
            margin : '0 0 0 10'
       }); 
       
       this.timeSpanVolume  = Ext.create('Ext.form.field.Number', {
            fieldLabel : "",
            margin : '0 0 0 10',
            width : 50,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 100
       });
       
       var lblSetVolume2  = Ext.create('Ext.form.Label',{
            text : "%",
            align : 'middle',
            cls : 'x-form-item-label',
            margin : '0 0 0 2'
       }); 
       
       this.rowVolume = Ext.create('Ext.container.Container', {
            defaultType : 'numberfield',
            items : [this.checkVolume, lblSetVolume, this.timeSpanVolume, lblSetVolume2],
            layout : 'column',
            margin : '5 0 5 10',
            width : 650
        });
        this.bVolumeRowIsEnabled = true;
        
       if(!this.dialogPreset) {
        /* REPEAT MUSIC */
         this.checkRepeat = Ext.create('Ext.form.field.Checkbox', {
                                        fieldLabel : "",
                                        align : 'middle',
                                        listeners:{
                                          'change': function(checkbox, newVal, oldVal){
                                             if (newVal > 0 && me.timeSpanRepeat.getValue() < 1) {
                                               me.timeSpanRepeat.setValue(1);         
                                             }
                                             me.handleRepeatPreviusMusicControl();
                                          }
                                        }                                      
                                      });

         var lblRepeat = Ext.create('Ext.form.Label',{
              text : _("Repeat music for maximum of"),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 10'
         }); 
         
         this.timeSpanRepeat  = Ext.create('Ext.form.field.Number', {
              fieldLabel : "",
              margin : '0 0 0 10',
              width : 50,
              step : 1,
              value : 0,
              minValue : 1,
              maxValue : 10
         });
         
         var lblRepeat2 = Ext.create('Ext.form.Label',{
              text : _("minutes"),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 5'
         }); 

         this.rowRepeat = Ext.create('Ext.container.Container', {
              defaultType : 'numberfield',
              items : [this.checkRepeat, lblRepeat, this.timeSpanRepeat, lblRepeat2],
              layout : 'column',
              margin : '5 0 5 10',
              width : 650
          });
        
          /* RESTART MUSIC */
         this.checkRestart = Ext.create('Ext.form.field.Checkbox', {
                                        fieldLabel : "",
                                        align : 'right',
                                        listeners:{
                                          'change': function(checkbox, newVal, oldVal){
                                                     }
                                        }                                      
                                      });
                                      
         var lblRestart = Ext.create('Ext.form.Label',{
              text : _("Restart previous music once finished"),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 10'
         }); 
         
         this.rowRestart = Ext.create('Ext.container.Container', {
              defaultType : 'numberfield',
              items : [this.checkRestart, lblRestart],
              layout : 'column',
              margin : '5 0 5 10',
              width : 650
          });
          
          this.btnTestPlay = Ext.create('Ext.Button', {
                text : _("Play"),
                iconCls : 'icon-start-test-play',
                width : 115,
                margin : '5 0 0 0',
                handler : function() {
                  if (!me.testPlayStatusPlaying) {
                    var oSelectionLVL1 = me.grids[me.parentDialog].lvl1.getSelectionModel().getSelection();
                    if (oSelectionLVL1[0] != null) {
                      var nDesiredVolume=-1;
                      if (me.checkVolume.getValue()) {
                         nDesiredVolume=me.timeSpanVolume.getValue();
                      }
                      var oSelectedRooms=me.dssEditor.editControls.selectedRoom.getValue();
                      var sendPlayParams = new Object();
                      if (oSelectedRooms.rooms!=null) {
                          sendPlayParams.rooms=oSelectedRooms.rooms;
                      }
                      sendPlayParams.nDesiredVolume=nDesiredVolume;
                     
                      sendPlayParams.nActionType = oSelectionLVL1[0].get('_id');
                      sendPlayParams.sUrlCall = "";
                      sendPlayParams.bIsRadio = false;
                      sendPlayParams.autoStop = false;
                      sendPlayParams.t2sCreateFile = false;
                      sendPlayParams.t2sText = "";
                      sendPlayParams.t2sLang = "";
                      sendPlayParams.t2sVoice = "";
                      sendPlayParams.t2sFolder = "";
                      
                      switch(sendPlayParams.nActionType) {
                        case 1: // playlist
                          var oSelectionPlaylist = me.grids[me.parentDialog].lvlPlaylist.getSelectionModel().getSelection();
                          sendPlayParams.sUrlCall = oSelectionPlaylist[0].get('listUrl');
                        break;
                        
                        case 2:
                          var oSelectionFavorites = me.grids[me.parentDialog].lvlFavorites.getSelectionModel().getSelection();
                          sendPlayParams.sUrlCall = oSelectionFavorites[0].get('listUrl');
                          sendPlayParams.bIsRadio = (oSelectionFavorites[0].get('name').indexOf("TuneIn Station") > -1);
                          sendPlayParams.sMetaData = escape(oSelectionFavorites[0].get('metaData'));
                          if (!sendPlayParams.bIsRadio)
                            sendPlayParams.autoStop = true;
                        break;
                        
                        case 3:
                          var oSelectionMedia = me.grids[me.parentDialog].lvlMediaFiles.getSelectionModel().getSelection();
                          if (oSelectionMedia.length == 0)
                            oSelectionMedia = me.grids[me.parentDialog].lvlMediaGroupsSub.getSelectionModel().getSelection(); 

                          sendPlayParams.sUrlCall = oSelectionMedia[0].get('_id');
                          sendPlayParams.autoStop = true;
                        break;

                        case 4:
                          if (me.comboTextLang.getValue() != "" && me.comboTextVoice.getValue() != "" && (me.txt2Speech.getValue().trim() != "")) {
                            if (me.txt2Speech.getValue().trim().length <= me.arraySpeechSettings.maxTextLength) {
                                sendPlayParams.autoStop = true;
                                if (me.t2sCreatedObj.guid != "" && 
                                    me.comboTextLang.getValue() == me.t2sCreatedObj.lang &&
                                    me.comboTextVoice.getValue() == me.t2sCreatedObj.voice &&
                                    me.txt2Speech.getValue().trim() == me.t2sCreatedObj.text
                                   ) {
                                  sendPlayParams.sUrlCall = me.t2sCreatedObj.guid;  
                                }
                                else {
                                  sendPlayParams.t2sText = me.txt2Speech.getValue().trim();
                                  sendPlayParams.t2sLang = me.comboTextLang.getValue();
                                  sendPlayParams.t2sVoice = me.comboTextVoice.getValue();
                                  sendPlayParams.t2sFolder = me.t2sGUIDFolder;
                                  sendPlayParams.t2sCreateFile = true;
                                  sendPlayParams.t2sDeleteGuid = "";
                                  
                                  // we must delete old file 
                                  if (me.t2sCreatedObj.guid != "" && me.t2sCreatedObj.guid != me.t2sCreatedObj.originalGuid) {
                                    sendPlayParams.t2sDeleteGuid = me.t2sCreatedObj.guid;
                                    me.t2sCreatedObj.guid = "";
                                  } 
                                }
                            }
                            else 
                                Ext.MessageBox.alert(_('Info'), _('Text is too long. Maximum allowed length is %speechSize characters!').replace("%speechSize", me.arraySpeechSettings.maxTextLength), null);
                          }
                          else 
                            Ext.MessageBox.alert(_('Info'), _("Missing required field to play Text to speech!"), null);
                        break;
                      }
                      
                      if (sendPlayParams.sUrlCall != "" || sendPlayParams.t2sCreateFile) {
                        this.setText(_("Stop"));
                        this.setIconCls("icon-stop-test-play");
                        
                        me.testPlayStatusPlaying = true;
                        me.testPlayStopSubscriptID = 0;
                        
                        var sSendParams = Ext.JSON.encode(sendPlayParams);
                        
                        dss.raiseEvent('sonos-controller.testPlay', {
                                        actions : 'play',
                                        value : sSendParams
                                    });
                        
                        if (sendPlayParams.autoStop) {
                          me.testPlayStopSubscriptID = Math.floor(Math.random() * 100000000000);
                                      
                          dss.ajaxSyncRequest('/json/event/subscribe', {
                                            subscriptionID : me.testPlayStopSubscriptID,
                                            name : 'sonos-controller-test-play-stopped'
                                        });
                          dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                                            subscriptionID : me.testPlayStopSubscriptID,
                                            timeout : 180 * 1000
                                        }, function() {
                                         
                                          dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                                              subscriptionID : me.testPlayStopSubscriptID,
                                              name : 'sonos-controller-test-play-stopped'
                                          });
                                          
                                          me.btnTestPlay.setText(_("Play"));
                                          me.btnTestPlay.setIconCls("icon-start-test-play");
                                          me.testPlayStopSubscriptID = 0;

                                          me.testPlayStatusPlaying = false;
                                          //dss.raiseEvent('sonos-controller.testPlay', {actions : 'stop'});
                                        });
                        }
                        
                        if (sendPlayParams.t2sCreateFile) {
                          // catching created GUID from t2s
                          me.testPlayCreateSubscriptID = Math.floor(Math.random() * 100000000000);
                                      
                          dss.ajaxSyncRequest('/json/event/subscribe', {
                                            subscriptionID : me.testPlayCreateSubscriptID,
                                            name : 'sonos-controller-test-t2s-create'
                                        });
                          dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                                            subscriptionID : me.testPlayCreateSubscriptID,
                                            timeout : 30 * 1000
                                        }, function(sValue) {
                                         
                                          dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                                              subscriptionID : me.testPlayCreateSubscriptID,
                                              name : 'sonos-controller-test-t2s-create'
                                          });
                                          
                                          if (sValue != "") {
                                            var returnData = JSON.parse(sValue);
                                            if (returnData.result != null &&
                                                returnData.result.events != null && 
                                                returnData.result.events.length>0) {
                                              var aInfo = returnData.result.events[0]; 
                                              if (aInfo != null) {
                                                var oData = JSON.parse(unescape(aInfo.properties.value));
                                                if (oData.ReturnMessage == "OK" && 
                                                    oData.Response != null &&
                                                    oData.Response.TextToSpeechVoiceFileGuid != null ) {
                                                  me.t2sCreatedObj.guid = unescape(oData.Response.TextToSpeechVoiceFileGuid);
                                                  me.t2sCreatedObj.lang = me.comboTextLang.getValue();
                                                  me.t2sCreatedObj.voice = me.comboTextVoice.getValue();
                                                  me.t2sCreatedObj.text = me.txt2Speech.getValue().trim();
                                                }
                                                else {
                                                  me.btnTestPlay.setText(_("Play"));
                                                  me.btnTestPlay.setIconCls("icon-start-test-play");

                                                  me.testPlayStatusPlaying = false;
                                                  var nError = parseInt("" + oData.ReturnCode);
                                                  switch (nError) {
                                                    case 79:
                                                      Ext.MessageBox.alert(_('Error creating Text To Speech file'), _("The maximal number of created text messages per day was exceeded. Please try again tomorrow."), null);
                                                    break;
                                                    
                                                    default:
                                                      Ext.MessageBox.alert(_('Error creating Text To Speech file'), oData.ReturnMessage, null);
                                                    break;
                                                  }
                                                  this.t2sCreatedObj.error  = nError;
                                                }
                                              }
                                            }
                                          }
                                        });
                        }
                      }
                    }
                  }
                  else {
                    this.setText(_("Play"));
                    this.setIconCls("icon-start-test-play");

                    me.testPlayStatusPlaying = false;
                    dss.raiseEvent('sonos-controller.testPlay', {actions : 'stop'});
                    if (me.testPlayStopSubscriptID > 0)
                      dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                          subscriptionID : me.testPlayStopSubscriptID,
                          name : 'sonos-controller-test-play-stopped'
                      });
                      me.testPlayStopSubscriptID = 0;
                  } 
                  
                }
            });
          this.btnTestPlay.disable();
       }
                                    
      
       var oTabPanelL = Ext.create('Ext.panel.Panel', {
                          border : false,
                          defaults: {style: {float: 'left'}},
                          items : [  this.rowVolume, this.rowRepeat, this.rowRestart ],
                          width:640
                        });
       var oTabPanelR = Ext.create('Ext.panel.Panel', {
                          border : false,
                          defaults: {style: {float: 'right'}},
                          items : [this.btnTestPlay],
                          width:120
                        });
               
       this.grids[this.parentDialog].pnlExtraFields = Ext.create('Ext.container.Container', {
           defaultType : 'numberfield',
           items : [  oTabPanelL, oTabPanelR ],
           layout : 'column',
           margin : '5 0 5 0',
           width : 760 });
           
     
       this.add(this.grids[this.parentDialog].pnlExtraFields);
}
catch (e){
   //alert("WtP constructActivityFields "+e.message);
}         
    },
    constructMacGrids : function() {
     // if (this.grids.lvl1==null) {
      this.grids[this.parentDialog].lvl1 = Ext.create('Ext.grid.Panel', {
             hideHeaders:true,
             height : this.iDefaultHeight,
             width : this.iDefaultWidth,
             autoScroll : true,
             viewConfig : {
                 stripeRows : true
             },
             selModel : {
                 mode : 'SINGLE'
             },
             store : Ext.data.StoreManager.lookup('whattoplay_l1Store_'+this.parentDialog),
             columns : [ {
                 sortable : false,
                 hideable : false,
                 dataIndex : 'name',
                 flex : 1,
                 renderer : this.defMacGridRenderer
             } ]
         });
      this.grids[this.parentDialog].lvl1.getSelectionModel().store = this.grids[this.parentDialog].lvl1.store;
      this.grids[this.parentDialog].lvl1.parent = this;
 
      this.grids[this.parentDialog].lvl1.on('itemclick', function(grid, record) {
             this.parent.nowFileType = -1;
             this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlNowRooms);
             this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlNowPlaying);
             this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlPlaylist);
             this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlFavorites);
             if (!this.dialogPreset) {
               this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlMediaGroups); 
               this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlMediaGroupsSub); 
               this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlMediaFiles); 
               this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlText2Speech);
               this.parent.preparePlayButton(false);
               
             }
             this.parent.macPanel.remove(this.parent.grids[this.parent.parentDialog].lvlCommands);
             
             var fIsPassive=false;
             if (record.get('passive')!=null) {
                 if (record.get('passive')==true) {
                     this.getSelectionModel().deselect(record);
                     fIsPassive=true;
                 }
             }
             this.parent.preparePlayExtraControls(-1);

             if (!fIsPassive) {
                 if (record.get('_id') == 0) { // nowPlaying
                     this.parent.constructGridLvlNowPlaying();
                     this.getSelectionModel().deselectAll();
                     this.getSelectionModel().select(record);
                 }
                 else if (record.get('_id') == 1) { // playlist
                     this.parent.constructGridLvlPlaylist();
                     this.getSelectionModel().deselectAll();
                     this.getSelectionModel().select(record);
                 }
                 else if (record.get('_id') == 2) { // favorites
                     this.parent.constructGridLvlFavorites();
                     this.getSelectionModel().deselectAll();
                     this.getSelectionModel().select(record);
                 }
                 else if (record.get('_id') == 3) { // Media lib
                     this.parent.constructGridLvlMediaLib();
                     this.getSelectionModel().deselectAll();
                     this.getSelectionModel().select(record);
                     var sRemoteWarning = this.parent.getRemoteErrorText(this.parent.arrayMediaLibrary);
                     if (sRemoteWarning != "") {
                       Ext.MessageBox.alert(_('Info'), sRemoteWarning, null);  
                     }
                 }
                 else if (record.get('_id') == 4) { // Text2Speech
                     this.parent.constructGridLvlText2Speech();
                     this.getSelectionModel().deselectAll();
                     this.getSelectionModel().select(record);

                     var sRemoteWarning = this.parent.getRemoteErrorText(this.parent.arraySpeechSettings);
                     if (sRemoteWarning != "") {
                       Ext.MessageBox.alert(_('Info'), sRemoteWarning, null);  
                     }
                 } 
                 else if (record.get('_id') == 5) { // commands
                     this.parent.constructGridLvlCommands();
                     this.getSelectionModel().deselectAll();
                     this.getSelectionModel().select(record);
                 }
                 this.parent.nActionType = record.get('_id'); 
             }
             
             if (!this.parent.dialogPreset) {
               this.parent.handleRepeatPreviusMusicControl();
             }
         }); 
      if(!this.macPanel.contains(this.grids[this.parentDialog].lvl1, true))
        this.macPanel.add(this.grids[this.parentDialog].lvl1);
     // }
    },
    constructor : function(config) {
       if(config.parent == 'Preset')
       {
         this.dialogPreset = true;
         this.parentDialog = 'preset';
         this.iDefaultHeight = 290;
       } 
       else {
         this.dialogPreset = false;
         this.parentDialog = 'activity';
         this.iDefaultHeight = 220;
       }
       this.macPanel = Ext.create('Ext.panel.Panel', {
              border : '0',
              autoScroll : true,
              height : this.iDefaultHeight+2,
              layout : {
                  type : 'hbox'
              },
              items : [  ],//this.grids.lvl1
              scroll : 'horizontal'
          });
          Ext.apply(this, {
              items : [ this.macPanel]
          });

         this.callParent(arguments);
    },
    clearGridLevels : function() {
      if (this.grids[this.parentDialog].lvl1 != null) {
         this.macPanel.remove(this.grids[this.parentDialog].lvl1);
      }
      if (this.grids[this.parentDialog].lvlNowPlaying != null) {
         this.macPanel.remove(this.grids[this.parentDialog].lvlNowRooms); 
         this.macPanel.remove(this.grids[this.parentDialog].lvlNowPlaying); 
      }
      if (this.grids[this.parentDialog].lvlPlaylist != null) {
         this.macPanel.remove(this.grids[this.parentDialog].lvlPlaylist); 
      }
      if (this.grids[this.parentDialog].lvlFavorites != null) {
        this.macPanel.remove(this.grids[this.parentDialog].lvlFavorites); 
      }
      if (this.grids[this.parentDialog].lvlMediaGroups != null) {
        this.macPanel.remove(this.grids[this.parentDialog].lvlMediaGroups); 
        this.macPanel.remove(this.grids[this.parentDialog].lvlMediaGroupsSub); 
        this.macPanel.remove(this.grids[this.parentDialog].lvlMediaFiles); 
      }
      if (this.grids[this.parentDialog].lvlText2Speech != null) {
        this.macPanel.remove(this.grids[this.parentDialog].lvlText2Speech);
      }
      if (this.grids[this.parentDialog].lvlCommands != null) {
        this.macPanel.remove(this.grids[this.parentDialog].lvlCommands);
      }
      if (this.grids[this.parentDialog].pnlExtraFields != null) {
         this.remove(this.grids[this.parentDialog].pnlExtraFields);
      }
    },
    reset : function() {
try {
      me = this;
      this.clearGridLevels();
      this.nowFileType = -1;
      
      this.t2sCreatedObj = new Object();
      this.t2sCreatedObj.lang = ""
      this.t2sCreatedObj.voice = ""
      this.t2sCreatedObj.text = ""
      this.t2sCreatedObj.guid = ""
      this.t2sCreatedObj.originalGuid  = ""
      this.t2sCreatedObj.url  = ""
      this.t2sCreatedObj.error  = ""
           
      this.initLvl1();
      this.constructMacGrids();
      this.initStores();
      
      this.checkVolume.setValue(false); 
      this.timeSpanVolume.setValue(0);
      if (!this.dialogPreset) {
        this.checkRepeat.setValue(false); 
        this.timeSpanRepeat.setValue(0);
        this.checkRestart.setValue(false); 
      }

      this.preparePlayExtraControls(-1);
      this.grids[this.parentDialog].lvl1.getSelectionModel().deselectAll();
      
      // handling trigger selection item
      if (!this.dialogPreset) {
          this.dssEditor.editControls.triggers.grids.lvl1.on('itemclick', function(grid, record) {
                    me.handleRepeatPreviusMusicControl();
                    if (me.dssEditor.editControls.triggers.grids.lvlPanic != null) {
                        me.dssEditor.editControls.triggers.grids.lvlPanic.on('itemclick', function(grid, record) {
                          me.handleRepeatPreviusMusicControl();
                        });
                    }
          });
          this.handleRepeatPreviusMusicControl();
      }
}
catch (e){
   //alert("WtP reset "+e.message);
}      
    },
    setValue : function(values) {
     try {
        this.clearGridLevels();
        this.nowFileType = -1;

        this.t2sCreatedObj = new Object();
        this.t2sCreatedObj.lang = ""
        this.t2sCreatedObj.voice = ""
        this.t2sCreatedObj.text = ""
        this.t2sCreatedObj.guid = ""
        this.t2sCreatedObj.originalGuid  = ""
        this.t2sCreatedObj.url  = ""
        this.t2sCreatedObj.error  = ""
      
        this.initLvl1();
        this.constructMacGrids();
        this.initStores();
        
        this.checkVolume.setValue(false); 
        this.timeSpanVolume.setValue(0);
        if (!this.dialogPreset) {
          this.checkRepeat.setValue(false); 
          this.timeSpanRepeat.setValue(0);
          this.checkRestart.setValue(false); 
        }
        
        var nSelectedID = this.dssEditor.editControls.id.getValue();
        if (nSelectedID != null) { // edit existing dialog
          if (this.dialogPreset) {
            var sString = dss.ajaxSyncRequest('/json/property/query', {
                                              'query' : '/scripts/sonos-controller/sonos-presets/'+nSelectedID+'(*)'
                                            });
            var result = Ext.JSON.decode(sString);
            var arrayData = dss.parsePropertyQueryAnswer(result,[{name:'actionType',type:'simple'},
                                                                 {name:'playListSonosID', type:'simple'},
                                                                 {name:'favoritesSonosID', type:'simple'},
                                                                 {name:'nowAction', type:'simple'},
                                                                 {name:'nowSingleTitle', type:'simple'},
                                                                 {name:'nowSingleIsRadio', type:'simple'},
                                                                 {name:'nowSingleArtist', type:'simple'},
                                                                 {name:'nowSingleUrl', type:'simple'},
                                                                 {name:'nowSingleLength', type:'simple'},
                                                                 {name:'command', type:'simple'},
                                                                 {name:'volumeSet', type:'simple'},
                                                                 {name:'volume', type:'simple'}]); 
          }
          else {
            var sString = dss.ajaxSyncRequest('/json/property/query', {
                                              'query' : '/scripts/sonos-controller/sonos-activities/'+nSelectedID+'(*)'
                                            });
            var result = Ext.JSON.decode(sString);
            var arrayData = dss.parsePropertyQueryAnswer(result,[{name:'actionType',type:'simple'},
                                                                 {name:'playListSonosID', type:'simple'},
                                                                 {name:'favoritesSonosID', type:'simple'},
                                                                 {name:'nowAction', type:'simple'},
                                                                 {name:'volumeSet', type:'simple'},
                                                                 {name:'volume', type:'simple'},
                                                                 {name:'setRepeat', type:'simple'},
                                                                 {name:'repeatTime', type:'simple'},
                                                                 {name:'restartAfter', type:'simple'},
                                                                 {name:'createSonosGroup', type:'simple'},
                                                                 {name:'nowSingleTitle', type:'simple'},
                                                                 {name:'nowSingleIsRadio', type:'simple'},
                                                                 {name:'nowSingleArtist', type:'simple'},
                                                                 {name:'nowSingleUrl', type:'simple'},
                                                                 {name:'nowSingleLength', type:'simple'},
                                                                 {name:'mediaFileGUID', type:'simple'},
                                                                 {name:'mediaGroupGUID', type:'simple'},
                                                                 {name:'mediaGroupSubGUID', type:'simple'},
                                                                 {name:'t2Stext', type:'simple'},
                                                                 {name:'t2SlangID', type:'simple'},
                                                                 {name:'t2SvoiceID', type:'simple'},
                                                                 {name:'t2Sguid', type:'simple'},
                                                                 {name:'command', type:'simple'}]); 
          }
          
          if (arrayData != null) {
            var sceneData = arrayData[0];
           
            this.nActionType = parseInt("" + sceneData.actionType,10);
           
            var oRecordZone = this.grids[this.parentDialog].lvl1.store.find('_id',sceneData.actionType,false,false,true);
            this.grids[this.parentDialog].lvl1.getSelectionModel().select(oRecordZone,true);  
            switch(this.nActionType) {
              case 0:
                this.constructGridLvlNowPlaying();
                
                if (!this.dialogPreset) {
                  var oSelection = this.grids[this.parentDialog].lvlNowRooms.getSelectionModel();
                  if (oSelection != null) { 
                    oSelection.select(0);
                    this.sSelectedRoomIP = oSelection.getSelection()[0].get('playerIP');  
                  }
                  this.macPanel.add(this.grids[this.parentDialog].lvlNowPlaying);
                }
                
                this.lblNowPlayed.setVisible(false);
                this.gridQueue.setVisible(false);
                
                this.nowFileType = parseInt("" + sceneData.nowAction,10);
                var sTitle = "";
                if (this.nowFileType == 0) { // single song/radio
                  if (sceneData.nowSingleTitle != "") {
                    this.bIsRadio = false;
                    sTitle = _("Song: ");
                    if (JSON.parse(sceneData.nowSingleIsRadio)) {
                      sTitle = _("Radio: ");
                      this.bIsRadio = true;
                    }
                    
                    if (sceneData.nowSingleTitle != "")
                      sTitle += sceneData.nowSingleTitle;
                    if (sceneData.nowSingleArtist != "")
                      sTitle += " ("+sceneData.nowSingleArtist+")";
                    this.selectedSong = new Object({changed:false, 
                                                    isRadio:this.bIsRadio,
                                                    url:sceneData.nowSingleUrl,
                                                    title: sceneData.nowSingleTitle,
                                                    artist: sceneData.nowSingleArtist,
                                                    length: sceneData.nowSingleLength
                    });
                  }                
                  this.lblNowPlayed.setText(unescape(sTitle));               
                  this.lblNowPlayed.setVisible(true);
                }
                else { // Active queue
                  var sPath = "sonos-presets";
                  if (!this.dialogPreset)
                    sPath = "sonos-activities";
                  sString = dss.ajaxSyncRequest('/json/property/query', {
                       'query' : '/scripts/sonos-controller/'+sPath+'/'+nSelectedID+'/active-queue/*(*)/*(*)/*(*)/*(*)'
                   });            
                  var result = Ext.JSON.decode(sString);
                  var arrayQueue = dss.parsePropertyQueryAnswer(result,[{name:'id', type:'simple'},
                                                                        {name:'title', type:'simple'},
                                                                        {name:'artist',type:'simple'}]); 
                  if (arrayQueue != null && arrayQueue.length > 0) {
                    var arrayFiles  = new Array();
                    for ( var iIndex = 0; iIndex < arrayQueue.length; iIndex++) {
                      arrayFiles.push(new Object({'_id':iIndex, 'name':unescape((iIndex+1)+". "+arrayQueue[iIndex].title)}));
                    }
                    Ext.data.StoreManager.lookup('whattoplay_queue').add(arrayFiles);  
                    this.gridQueue.setVisible(true);
                    this.selectedQueue = new Object({changed:false});
                  }
                }
              break;
              
              case 1:
                this.constructGridLvlPlaylist();
                var oRecordZone = this.grids[this.parentDialog].lvlPlaylist.store.find('_id', unescape(sceneData.playListSonosID), 0, false,false,true);
                if (oRecordZone != -1) {
                  this.grids[this.parentDialog].lvlPlaylist.getSelectionModel().select(oRecordZone);
                  this.preparePlayButton(true);
                }
              break;
              
              case 2:
                this.constructGridLvlFavorites();
                var oRecordZone = this.grids[this.parentDialog].lvlFavorites.store.find('_id', unescape(sceneData.favoritesSonosID), 0, false,false,true);
                if (oRecordZone != -1) {
                  this.grids[this.parentDialog].lvlFavorites.getSelectionModel().select(oRecordZone);
                  this.preparePlayButton(true);
                }
              break;
              
              case 3:
                this.macPanel.remove(this.grids[this.parentDialog].lvlMediaGroups); 
                this.macPanel.remove(this.grids[this.parentDialog].lvlMediaGroupsSub); 
                this.macPanel.remove(this.grids[this.parentDialog].lvlMediaFiles); 
                this.constructGridLvlMediaLib();
              
                var oRecordZone = this.grids[this.parentDialog].lvlMediaGroups.store.find('_id', unescape(sceneData.mediaGroupGUID), 0, false,false,true);
                if (oRecordZone != -1) {
                  this.grids[this.parentDialog].lvlMediaGroups.getSelectionModel().select(oRecordZone);
                  var record = this.grids[this.parentDialog].lvlMediaGroups.getSelectionModel().getSelection();
                  
                  if (record != null && record[0] != null) {
                    var sMediFileGroup = "";
                    if (record[0].get('hasSubGroup') != "") { 
                      this.fillMediaSubGrid(record[0].get('_id'));
                      sMediFileGroup = sceneData.mediaGroupSubGUID;
                      this.grids[this.parentDialog].lvlMediaGroupsSub.show();
                      this.grids[this.parentDialog].lvlMediaFiles.setWidth(284);
                      
                      // setting sub folder
                      var oRecordZone2 = this.grids[this.parentDialog].lvlMediaGroupsSub.store.find('_id', sceneData.mediaGroupSubGUID, 0, false,false,true);
                      if (oRecordZone2 != -1) {
                        this.grids[this.parentDialog].lvlMediaGroupsSub.getSelectionModel().select(oRecordZone2);
                        oSelectionGroupSub = this.grids[this.parentDialog].lvlMediaGroupsSub.getSelectionModel().getSelection();
                        this.preparePlayButton(!oSelectionGroupSub[0].get('next'));
                      }
                    }
                    else {
                     // no sub folders
                      this.grids[this.parentDialog].lvlMediaFiles.setWidth(454);
                      sMediFileGroup = record[0].get('_id');
                    }
                    
                    if (sMediFileGroup != "") {
                      this.fillMediaFilesGrid(sMediFileGroup);
                     
                      oRecordZone = this.grids[this.parentDialog].lvlMediaFiles.store.find('_id', sceneData.mediaFileGUID, 0, false,false,true);
                      if (oRecordZone != -1) {
                        this.grids[this.parentDialog].lvlMediaFiles.getSelectionModel().select(oRecordZone);
                        this.grids[this.parentDialog].lvlMediaFiles.show();
                        this.preparePlayButton(true);
                      }
                    }
                  }
                }  
                
                var sRemoteWarning = this.getRemoteErrorText(this.arrayMediaLibrary);
                if (sRemoteWarning != "") {
                  Ext.MessageBox.alert(_('Info'), sRemoteWarning, null);  
                }
              break;
              
              case 4:
                this.macPanel.remove(this.grids[this.parentDialog].lvlText2Speech);
                this.constructGridLvlText2Speech();
                
                this.t2sCreatedObj.lang = sceneData.t2SlangID;
                this.t2sCreatedObj.voice = sceneData.t2SvoiceID;
                this.t2sCreatedObj.text = unescape(sceneData.t2Stext);
                this.t2sCreatedObj.guid = unescape(sceneData.t2Sguid);
                this.t2sCreatedObj.originalGuid  = unescape(sceneData.t2Sguid);
                this.t2sCreatedObj.url = unescape(sceneData.nowSingleUrl);
                
                this.txt2Speech.setValue(this.t2sCreatedObj.text);
                this.comboTextLang.setValue(this.t2sCreatedObj.lang);
                this.fillText2SpeechLanguage(this, this.comboTextLang.getValue());
                this.comboTextVoice.setValue(this.t2sCreatedObj.voice);
                
                var sRemoteWarning = this.getRemoteErrorText(this.arraySpeechSettings);
                if (sRemoteWarning != "") {
                  Ext.MessageBox.alert(_('Info'), sRemoteWarning, null);  
                }
              break;
              
              case 5:
                this.constructGridLvlCommands();
                var oRecordZone = this.grids[this.parentDialog].lvlCommands.store.find('_id', unescape(sceneData.command), 0, false,false,true);
                if (oRecordZone != -1) {
                  this.grids[this.parentDialog].lvlCommands.getSelectionModel().select(oRecordZone);
                }
                this.preparePlayExtraControls(parseInt(""+sceneData.command,10));

              break;
            }
            
            if (JSON.parse(sceneData.volumeSet)) {
              this.checkVolume.setValue(true);
              this.timeSpanVolume.setValue(sceneData.volume);
            }
            if (!this.dialogPreset) {
              if (JSON.parse(sceneData.setRepeat)) {
                this.checkRepeat.setValue(true);
                this.timeSpanRepeat.setValue(sceneData.repeatTime);
              }

              if (JSON.parse(sceneData.restartAfter)) 
                this.checkRestart.setValue(true);
            }
          }
        }
        
        if (!this.dialogPreset)
          this.handleRepeatPreviusMusicControl();

      }
      catch (e){
//alert("WtP setValue "+e.message);
      }
    },
    isValid : function() {
       var bValid = false;
       var bCheckFileLength = true;
     
       var oSelectionLVL1 = this.grids[this.parentDialog].lvl1.getSelectionModel().getSelection();
     
       var bSelectedData = this.checkIfSelectedItemIsSingleFile(true);
       bValid = bSelectedData.bValidSelection;
       
       var nVolume = parseInt("" +this.timeSpanVolume.getValue(), 10);
       if (bValid && (nVolume < 0 || nVolume > 100 )) {
         Ext.MessageBox.alert(_('Info'), _("Invalid volume value!"), null);
         bValid = false;
       }
       
       if (!this.dialogPreset && bCheckFileLength) {
         var nTime = parseInt("" +this.timeSpanRepeat.getValue(), 10);
         if (bValid && this.checkRepeat.checked && nTime == 0) {
           Ext.MessageBox.alert(_('Info'), _("Repeated time in minutes is missing!"), null);
           bValid = false;
         }

         if (bValid && this.checkRepeat.checked && (nTime < 1 || nTime > 10)) {
           Ext.MessageBox.alert(_('Info'), _("Repeated time in minutes is invalid. Only allowed values between 1 and 10!"), null);
           bValid = false;
         }
       }
       
       if (bValid && !this.dialogPreset && 
           oSelectionLVL1[0].get('_id')==4 && this.t2sCreatedObj.error != "") {
           Ext.MessageBox.alert(_('Info'), _("Repeated time in minutes is invalid. Only allowed values between 1 and 10!"), null);
           switch (nError) {
             case 79:
               Ext.MessageBox.alert(_('Info'), _("The maximal number of created text messages per day was exceeded. Please try again tomorrow."), null);
             break;
             
             default:
               Ext.MessageBox.alert(_('Info'), _("Cannot create Text to speech file."), null);
             break;
           }
           bValid = false;
         }
         
       if (!this.dialogPreset && bValid) // test if grouping is allowed, testing here so that we do not show more than one alert at the time to user
         this.dssEditor.editControls.selectedRoom.isGroupingAllowed(true, false);
       
       return bValid;
    },
    getValue : function() {
      var returnValue = new Object();
      try {
        var oSelectionLVL1 = this.grids[this.parentDialog].lvl1.getSelectionModel().getSelection();
        for ( var iIndex = 0; iIndex < oSelectionLVL1.length; iIndex++) {       
          if (oSelectionLVL1[iIndex].get('_id') == 0) { // nowPlaying
            var sSong = "";
            if (this.nowFileType == 0) // single track
              sSong = this.selectedSong
            else  // Active queue
              // problem when sending long data over url- on save we get 413 request entity too large
              // So in this case we store data temporary to PropertyTree(on button ""get queue"" click), and on saving we get queue from PT
              if (this.selectedQueue.changed)
                sSong = new Object({changed:true});

            returnValue.actionType = 0;
            returnValue.nowAction = this.nowFileType;
            returnValue.selectedData = sSong;
          }
          else
          if (oSelectionLVL1[iIndex].get('_id') == 1) { // playlist
            var oSelectionPlaylist = this.grids[this.parentDialog].lvlPlaylist.getSelectionModel().getSelection();
            returnValue.actionType = 1;
            returnValue.playListSonosID = oSelectionPlaylist[0].get('_id');
            returnValue.listUrl = oSelectionPlaylist[0].get('listUrl');
            returnValue.title = oSelectionPlaylist[0].get('name');
          }
          else
          if (oSelectionLVL1[iIndex].get('_id') == 2) { // favorites
            var oSelectionFavorites = this.grids[this.parentDialog].lvlFavorites.getSelectionModel().getSelection();
            returnValue.actionType = 2;
            returnValue.playListSonosID = oSelectionFavorites[0].get('_id');
            returnValue.listUrl = oSelectionFavorites[0].get('listUrl');
            returnValue.metaData = escape(oSelectionFavorites[0].get('metaData'));
            returnValue.title = oSelectionFavorites[0].get('name');
          }
          else
          if (oSelectionLVL1[iIndex].get('_id') == 3) { // media library
            var oSelectionGroup = this.grids[this.parentDialog].lvlMediaGroups.getSelectionModel().getSelection();
            var oSelectionGroupSub = this.grids[this.parentDialog].lvlMediaGroupsSub.getSelectionModel().getSelection();
            var oSelectionMedia = this.grids[this.parentDialog].lvlMediaFiles.getSelectionModel().getSelection();
            
            returnValue.actionType = 3;
            returnValue.mediaGroupGUID = oSelectionGroup[0].get('_id');
            returnValue.mediaGroupSubGUID = "";
            returnValue.title = "";
            returnValue.mediaFileGUID = "";

            if (oSelectionGroupSub != null && oSelectionGroupSub.length>0)
              if (oSelectionGroupSub[0] != null) {
                returnValue.mediaGroupSubGUID = oSelectionGroupSub[0].get('_id');
            }            
            
            if (oSelectionMedia != null && oSelectionMedia.length > 0) { 
              // selected from last panel
              returnValue.mediaFileGUID = oSelectionMedia[0].get('_id');
              returnValue.title = oSelectionMedia[0].get('name');
              if (oSelectionGroupSub != null && oSelectionGroupSub.length>0)
                if (oSelectionGroupSub[0].get('next')) // filename with language
                  returnValue.title = oSelectionGroupSub[0].get('name') + " (" + returnValue.title + ")";                
            }
            else {
              // selected file from subgroup
              returnValue.mediaFileGUID = oSelectionGroupSub[0].get('_id');
              returnValue.title = oSelectionGroupSub[0].get('name');
            }
          }
          else                          
          if (oSelectionLVL1[iIndex].get('_id') == 4) { // Text2Speech
            returnValue.actionType = 4;
            returnValue.t2sText = this.txt2Speech.getValue().trim();
            returnValue.t2sLangID = this.comboTextLang.getValue();
            returnValue.t2sVoiceID = this.comboTextVoice.getValue();
            returnValue.t2sGUID = "";
            returnValue.t2sOriginalGUID = "";
            if (this.t2sCreatedObj!= null) {
              if (
                  (this.t2sCreatedObj.text != ""  && this.t2sCreatedObj.text.trim() != returnValue.t2sText) ||
                  (this.t2sCreatedObj.voice != "" && returnValue.t2sVoiceID != this.t2sCreatedObj.voice)
                 )
                returnValue.t2sGUID = ""; // changed text or voice name we have to rebuild file
              else
                returnValue.t2sGUID = this.t2sCreatedObj.guid;
              
              if (this.t2sCreatedObj.originalGuid != null) 
                returnValue.t2sOriginalGUID = this.t2sCreatedObj.originalGuid;
            }
            returnValue.t2sFolder = this.t2sGUIDFolder;
          }
          
          if (oSelectionLVL1[iIndex].get('_id') == 5) { // Command
            var oSelectionCommand = this.grids[this.parentDialog].lvlCommands.getSelectionModel().getSelection();
            returnValue.actionType = 5;
            returnValue.command = oSelectionCommand[0].get('_id');
          }
        }
        
        returnValue.setVolume = false;
        returnValue.volume = 0; 
        if (this.bVolumeRowIsEnabled) {
            returnValue.setVolume = this.checkVolume.checked;
            returnValue.volume = parseInt("" +this.timeSpanVolume.getValue(),10); 
        }
        if (!this.dialogPreset) {
          if (oSelectionLVL1[0].get('_id') != 5) {
              // activity dialog, extra fields at bottom of grid
            returnValue.setRepeat = this.checkRepeat.checked;
            returnValue.repeatTime = this.timeSpanRepeat.getValue(); 
            returnValue.restartAfter = false;
            if (bRestartRowIsEnabled)
              returnValue.restartAfter = this.checkRestart.checked;
          }
          else {
            // default empty values for commands
            returnValue.setRepeat = false;
            returnValue.repeatTime = false; 
            returnValue.restartAfter = false;
          }
        }
      }
      catch (e){
//alert("WtP getValue "+e.message);
      }
      
      this.testPlayStopSubscriptID = 0;
      this.clearGridLevels();

      return returnValue;
    }    
});

Ext.define('DSS.addon.SelectRooms', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    getHeight:function () {
                 return 20;
    },
    nSelectedAction:-1,
    actionRoomsPanel:null,
    actionRoomsPanelMulti:null,
    actionTypeAll:null,
    lblActionRooms:null,
    rowExecRooms:null,
    checkGrouping:null,
    gridRooms:null,
    roomRenderer : function(val, metadata, record, colIdx, store, view) {
       var sPassive="";        
       if (record.get('passive')!=null && record.get('passive'))
         sPassive='style="color:#888888;"';
       var sReturn='<table style="height:16px;"><tr>';
       sReturn+='<td '+sPassive+' width="100%">' + record.get('roomName') + '</td>';
       return sReturn +'</tr></table>';      
    },
    isGroupingAllowed : function(bShowAlert, bResetValue) {
      var bIsOK = true;
      if (this.checkGrouping.checked) {
        var isSelectedSingleFile = false;
        switch(this.dssEditor.editControls.whatToPlay.nActionType) {
          case 0: // now playing
            if (this.dssEditor.editControls.whatToPlay.nowFileType == 0){// single song/radio
              isSelectedSingleFile = !this.dssEditor.editControls.whatToPlay.bIsRadio;
            }
          break;
          
          case 2: // favorites
            var oSelectionFavorites = this.dssEditor.editControls.whatToPlay.grids["activity"].lvlFavorites.getSelectionModel().getSelection();
            if (oSelectionFavorites != null && oSelectionFavorites.length > 0) 
              isSelectedSingleFile = oSelectionFavorites[0].get('isSingleTrack');
          break;
          
          case 3: // media lib
          case 4: // text2speech
          case 5: // command
            isSelectedSingleFile = true;
          break;
        }

        if (!isSelectedSingleFile && !this.dssEditor.editControls.whatToPlay.checkRepeat.checked) { 
          if (bShowAlert) 
            Ext.MessageBox.alert(_('Info'), _("Uknown activity execution length. Sonos grouping is not allowed!"), null);
            
          if (bResetValue) {
            this.suspendEvents(false);
            this.setValue(false); 
            this.resumeEvents();
          }
          bIsOK = false;
        }
      }
      return bIsOK;
    },
    constructor : function(config) {
         var me = this;             
         this.lblActionRooms  = Ext.create('Ext.form.Label',{
              text : _("Play music in:"),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 0'
         }); 

         this.actionTypeAll = Ext.create('Ext.form.RadioGroup', {
            fieldLabel : _(''),
            labelWidth : 340,
            items : [ {
                inputValue : 0,
                boxLabel : _('All rooms'),
                name : 'roomType'} ],
            columns : 1,
            columnWidth:400,
            width:400,
            padding : '0 0 2 0',
            listeners: {
              change: function(radiogroup, radio) {
                 if (radio.roomType != null) {
                   me.nSelectedAction = 0;
                   me.gridRooms.disable();
                   me.gridRooms.getSelectionModel().deselectAll();
                 }
              }
            }
         }); 

         this.actionTypeMulti = Ext.create('Ext.form.RadioGroup', {
            fieldLabel : _(''),
            labelWidth : 340,
            items : [ {
                inputValue : 1,
                boxLabel : _('Selected rooms'),
                name : 'roomType'} ],
            columns : 1,
            columnWidth:400,
            width:400,
            padding : '0 0 4 0',
            listeners: {
              change: function(radiogroup, radio) {
                 if (radio.roomType != null) {
                   me.nSelectedAction = 1;
                   me.gridRooms.enable();
                   me.gridRooms.getSelectionModel().deselectAll();
                 }
              }
            }
         }); 
     
         this.gridRooms = Ext.create('Ext.grid.Panel', {
             hideHeaders:true,
             autoScroll : true,
             width:300,
             height:220,
             margin : '0 0 0 20',
             viewConfig : {
                 stripeRows : true
             },
             selModel : {
                 mode : 'MULTI'
             },
             columns : [ {
                 sortable : false,
                 hideable : false,
                 dataIndex : 'roomID',
                 flex : 1,
                 renderer : this.roomRenderer
             } ]
         }); 
         

         this.actionRoomsPanel = Ext.create('Ext.container.Container', {
              defaultType : 'numberfield',
              items : [  this.actionTypeAll, this.actionTypeMulti, this.gridRooms],
              layout: {type: 'vbox'},
              margin : '0 0 0 10',
              width : 400
         });
         
         
         this.rowExecRooms = Ext.create('Ext.container.Container', {
              defaultType : 'numberfield',
              items : [this.lblActionRooms, this.actionRoomsPanel],
              layout : 'column',
              margin : '0 0 0 10',
              width : 530
          });
          
         this.checkGrouping = Ext.create('Ext.form.field.Checkbox', {
                                        fieldLabel : "",
                                        align : 'left',
                                        listeners:{
                                          'change': function(checkbox, newVal, oldVal){
                                             me.isGroupingAllowed(true, true);
                                          }
                                        }                                      
                                      });
                                      
         var lblGrouping = Ext.create('Ext.form.Label',{
              text : _("Group all players, if more than one (For testing only)"),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 10'
         }); 
         
         var rowGrouping = Ext.create('Ext.container.Container', {
              defaultType : 'numberfield',
              items : [this.checkGrouping, lblGrouping],
              layout : 'column',
              margin : '5 0 5 10',
              width : 730
          });
          

         var lblGroupingInfo = Ext.create('Ext.form.Label',{
              text : _("Notice: In combination with 'Restart previous music once finished' each player joined to group is introducing at least half a second delay in sound reproduction for target group."),
              align : 'middle',
              cls : 'x-form-item-label',
              margin : '0 0 0 35',
              width : 730
         }); 
          
        Ext.apply(this, {
            items : [this.rowExecRooms, rowGrouping, lblGroupingInfo]// 
        });                          
        this.callParent(arguments);
    },
    reset: function (){
      try{      
            this.gridRooms.reconfigure(Ext.data.StoreManager.lookup('whattoselect_rooms'));
            this.actionTypeAll.setValue({'roomType':0});
            this.gridRooms.disable();
            this.gridRooms.getSelectionModel().deselectAll();
            this.checkGrouping.suspendEvents(false);
            this.checkGrouping.setValue(false); 
            this.checkGrouping.resumeEvents();

      }
      catch (e){
         //alert("SelectRooms reset "+e.message);
      }
    },
    setValue:function (value){
     try{ 
      this.gridRooms.reconfigure(Ext.data.StoreManager.lookup('whattoselect_rooms'));
      this.gridRooms.getSelectionModel().deselectAll();
      this.gridRooms.disable();
      this.checkGrouping.suspendEvents(false);
      this.checkGrouping.setValue(false); 
      this.checkGrouping.resumeEvents();
      
      this.actionTypeAll.setValue({'roomType':0});
      var sString = dss.ajaxSyncRequest('/json/property/query', {
                                        'query' : '/scripts/sonos-controller/sonos-activities/'+this.dssEditor.editControls.id.getValue()+'(*)'
                                      });
      var result = Ext.JSON.decode(sString);
      var arrayData = dss.parsePropertyQueryAnswer(result,[{name:'allRooms',type:'simple'},
                                                           {name:'pickedRooms', type:'simple'},
                                                           {name:'createSonosGroup', type:'simple'}]); 
      if (arrayData != null) {
        var bAllRooms = JSON.parse(arrayData[0].allRooms);
        this.nSelectedAction = 0;
        if (!bAllRooms) {
          this.nSelectedAction = 1;
          this.gridRooms.enable();
          this.actionTypeAll.setValue({'roomType':1});
         
          var rooms = unescape(arrayData[0].pickedRooms).split(";");
          var missingRooms = new Array();
          var selected = new Array();
          var store = this.gridRooms.getStore();
          for ( var iIndex = 0; iIndex < rooms.length; iIndex++) {
            var foundRec = store.getAt(store.findExact('roomID', rooms[iIndex]));
            if (foundRec != null)
              selected.push(foundRec);
            else
              if (parseInt("" + rooms[iIndex],10) > 0)
                missingRooms.push(rooms[iIndex]);
          }
          
          if (missingRooms.length == 0) {
            this.gridRooms.getSelectionModel().select(selected);
          } 
          else {
            // we must add missing rooms to list
            for ( var iIndex = 0; iIndex < missingRooms.length; iIndex++) {
              var roomID = parseInt("" + arrayTmp[iIndex].roomID, 10); 
              if (roomID > 0) {
                store.insert(store.getCount, new Object({'roomName': dss.staticDataModel.getNameForZone(roomID),
                                                         'roomID' : missingRooms[iIndex],
                                                         'passive' : true }));
              }
            }  
            selected = [];
            for (var iIndex = 0; iIndex < rooms.length; iIndex++) {
              var foundRec = store.getAt(store.findExact('roomID', rooms[iIndex]));
              if (foundRec != null)
                selected.push(foundRec);
            }
            this.gridRooms.getSelectionModel().select(selected);
          }
        }
        
        if (JSON.parse(arrayData[0].createSonosGroup)) {
         this.checkGrouping.suspendEvents(false);
         this.checkGrouping.setValue(true); 
         this.checkGrouping.resumeEvents();
        }
        
      }
     }
     catch (e){
   //alert("SelectRooms setValue"+e.message);
     }
    },
    isValid:function(){
       var bValid = false;
       if (this.nSelectedAction == 0)
         bValid = true;
       else
         if (this.nSelectedAction == 1) 
           bValid = (this.gridRooms.getSelectionModel().getSelection().length > 0);

       var bGroupingAllowed = this.isGroupingAllowed(false, false);
       if (bValid && !bGroupingAllowed) {
         bValid = false;
       }
     
       return bValid;
    },
    getValue : function(){
      var returnValue = new Object();
      
      returnValue.action = this.nSelectedAction;
      if (this.nSelectedAction == 1) { // selected rooms
        var oSelectionRooms = this.gridRooms.getSelectionModel().getSelection();
        if (oSelectionRooms.length > 0) {
          returnValue.rooms = new Array();
          for ( var iIndex = 0; iIndex < oSelectionRooms.length; iIndex++) {       
            returnValue.rooms.push(parseInt("" + oSelectionRooms[iIndex].get('roomID'), 10));
          }
        }
      }
      
      returnValue.createSonosGroup = this.checkGrouping.checked;
      
      
      return returnValue;
    }
});

Ext.define('DSS.addon.ManualIP', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    getHeight:function () {
        return 20;
    },
    txtEnterIPParts: [],

    constructor : function(config) {
        Ext.apply(Ext.form.field.VTypes, {
            IPAddress:  function(v, field) {
                if (v == "")
                    return false;
                var partValue = parseInt(v);
                return (partValue < 255);
            },
            IPAddressText: _('Not valid IP address part'),
            IPAddressMask: /[\d]/i
        });

        var lblEnterIP  = Ext.create('Ext.form.Label',{
            text : _("Manually enter IP address") + ":",
            align : 'left',
            cls : 'x-form-item-label',
            margin : '0 50 0 10'
        }); 
       
        var lblDots = [];
        for (var i = 0; i < 3; i++) {
            lblDots[i]  = Ext.create('Ext.form.Label',{
                text : ".",
                align : 'left',
                cls : 'x-form-item-label',
                margin : '0 2 0 2'
            }); 
        }

        for (var i = 0; i < 4; i++) {
            this.txtEnterIPParts[i] = Ext.create('Ext.form.field.Text', {
                fieldLabel: "",
                labelWidth: 0,
                margin: '0 0 0 0',
                value: "",
                maxLength: 3,
                enforceMaxLength: true,
                vtype: 'radius',
                width: 30,
                vtype: 'IPAddress'
            });
        }
          
        var rowIpAddress = Ext.create('Ext.container.Container', {
            defaultType : 'numberfield',
            items : [ lblEnterIP, this.txtEnterIPParts[0], lblDots[0], this.txtEnterIPParts[1], lblDots[1], this.txtEnterIPParts[2], lblDots[2], this.txtEnterIPParts[3]],
            layout : 'column',
            margin : '2 0 5 0',
            width : 530
        });
       
        Ext.apply(this, { items : [ rowIpAddress ] });

        this.callParent(arguments); 
    },
    reset: function (){
        for (var i = 0; i < 4; i++) {
            this.txtEnterIPParts[i].setValue('');
        }
    },
    setValue:function (value){
        for (var i = 0; i < 4; i++) {
            this.txtEnterIPParts[i].setValue('');
        }
    },
    
    isValid:function(){
        var ipAddress = this.getValue();
        var bValid = isIpAddressValid(ipAddress, true); 
        if (!bValid) {
            Ext.MessageBox.alert(_('Info'), _("Incorrect IP Address!"), null);
        }
        return bValid;
    },
    getValue : function(){
        return this.txtEnterIPParts[0].getValue() + "." +
            this.txtEnterIPParts[1].getValue() + "." +
            this.txtEnterIPParts[2].getValue() + "." +
            this.txtEnterIPParts[3].getValue();
    }
});